# work_evolve_api

WorkEvolveApi - JavaScript client for work_evolve_api
workEvolve Restful API generated by Swagger
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.1.0
- Package version: 0.1.0
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install work_evolve_api --save
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing 
into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

Finally, switch to the directory you want to use your work_evolve_api from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

You should now be able to `require('work_evolve_api')` in javascript files from the directory you ran the last 
command above from.

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/YOUR_USERNAME/work_evolve_api
then install it via:

```shell
    npm install YOUR_USERNAME/work_evolve_api --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file, that's to say your javascript file where you actually 
use this library):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var WorkEvolveApi = require('work_evolve_api');

var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = "YOUR API KEY"
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix['Authorization'] = "Token"

var api = new WorkEvolveApi.ActionPermissionApi()

var tenantId = "tenantId_example"; // {String} ID of tenant to filter by

var role = "role_example"; // {String} ID of role to filter by

var permissionId = "permissionId_example"; // {String} Id of action permission to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
api.getActionPermissionById(tenantId, role, permissionId, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*WorkEvolveApi.ActionPermissionApi* | [**getActionPermissionById**](docs/ActionPermissionApi.md#getActionPermissionById) | **GET** /tenants/{tenantId}/roles/{role}/actionpermission/{permissionId} | Get an action permission resource by id
*WorkEvolveApi.ActionPermissionApi* | [**getAllActionPermissions**](docs/ActionPermissionApi.md#getAllActionPermissions) | **POST** /tenants/{tenantId}/roles/{role}/actionpermission/get | Get all action permissions resource
*WorkEvolveApi.ActionPermissionApi* | [**removeActionPermissionById**](docs/ActionPermissionApi.md#removeActionPermissionById) | **DELETE** /tenants/{tenantId}/roles/{role}/actionpermission/{permissionId} | Delete action permission resource by id
*WorkEvolveApi.ActionPermissionApi* | [**saveActionPermission**](docs/ActionPermissionApi.md#saveActionPermission) | **POST** /tenants/{tenantId}/roles/{role}/actionpermission | Save a new action permission resource
*WorkEvolveApi.ActionPermissionApi* | [**updateActionPermission**](docs/ActionPermissionApi.md#updateActionPermission) | **POST** /tenants/{tenantId}/roles/{role}/actionpermission/{permissionId} | Update action permission resource by id
*WorkEvolveApi.AddressBookApi* | [**getAddressBookById**](docs/AddressBookApi.md#getAddressBookById) | **GET** /tenants/{tenantId}/addressbooks/{addressBookId} | Get an addressbook resource by id
*WorkEvolveApi.AddressBookApi* | [**getAllAddressBooks**](docs/AddressBookApi.md#getAllAddressBooks) | **POST** /tenants/{tenantId}/addressbooks/get | Get all addressbooks resource
*WorkEvolveApi.AddressBookApi* | [**removeAddressBookById**](docs/AddressBookApi.md#removeAddressBookById) | **DELETE** /tenants/{tenantId}/addressbooks/{addressBookId} | Delete addressbook resource by id
*WorkEvolveApi.AddressBookApi* | [**saveAddressBook**](docs/AddressBookApi.md#saveAddressBook) | **POST** /tenants/{tenantId}/addressbooks | Save a new addressbook resource
*WorkEvolveApi.AddressBookApi* | [**updateAddressBook**](docs/AddressBookApi.md#updateAddressBook) | **POST** /tenants/{tenantId}/addressbooks/{addressBookId} | Update addressbook resource by id
*WorkEvolveApi.ApplicationPermissionApi* | [**getAllApplicationPermissions**](docs/ApplicationPermissionApi.md#getAllApplicationPermissions) | **POST** /tenants/{tenantId}/roles/{role}/applicationpermission/get | Get all application permissions resource
*WorkEvolveApi.ApplicationPermissionApi* | [**getApplicationPermissionById**](docs/ApplicationPermissionApi.md#getApplicationPermissionById) | **GET** /tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId} | Get an application permission resource by id
*WorkEvolveApi.ApplicationPermissionApi* | [**removeApplicationPermissionById**](docs/ApplicationPermissionApi.md#removeApplicationPermissionById) | **DELETE** /tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId} | Delete application permission resource by id
*WorkEvolveApi.ApplicationPermissionApi* | [**saveApplicationPermission**](docs/ApplicationPermissionApi.md#saveApplicationPermission) | **POST** /tenants/{tenantId}/roles/{role}/applicationpermission | Save a new application permission resource
*WorkEvolveApi.ApplicationPermissionApi* | [**updateApplicationPermission**](docs/ApplicationPermissionApi.md#updateApplicationPermission) | **POST** /tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId} | Update application permission resource by id
*WorkEvolveApi.ColumnPermissionApi* | [**getAllColumnPermissions**](docs/ColumnPermissionApi.md#getAllColumnPermissions) | **POST** /tenants/{tenantId}/roles/{role}/columnpermission/get | Get all column permissions resource
*WorkEvolveApi.ColumnPermissionApi* | [**getColumnPermissionById**](docs/ColumnPermissionApi.md#getColumnPermissionById) | **GET** /tenants/{tenantId}/roles/{role}/columnpermission/{permissionId} | Get a column permission resource by id
*WorkEvolveApi.ColumnPermissionApi* | [**removeColumnPermissionById**](docs/ColumnPermissionApi.md#removeColumnPermissionById) | **DELETE** /tenants/{tenantId}/roles/{role}/columnpermission/{permissionId} | Delete column permission resource by id
*WorkEvolveApi.ColumnPermissionApi* | [**saveColumnPermission**](docs/ColumnPermissionApi.md#saveColumnPermission) | **POST** /tenants/{tenantId}/roles/{role}/columnpermission | Save a new column permission resource
*WorkEvolveApi.ColumnPermissionApi* | [**updateColumnPermission**](docs/ColumnPermissionApi.md#updateColumnPermission) | **POST** /tenants/{tenantId}/roles/{role}/columnpermission/{permissionId} | Update column permission resource by id
*WorkEvolveApi.CustomerApi* | [**getAllCustomers**](docs/CustomerApi.md#getAllCustomers) | **POST** /tenants/{tenantId}/customers/get | Get all customers resource
*WorkEvolveApi.CustomerApi* | [**getCustomerById**](docs/CustomerApi.md#getCustomerById) | **GET** /tenants/{tenantId}/customers/{customerId} | Get a customer resource by id
*WorkEvolveApi.CustomerApi* | [**removeCustomerById**](docs/CustomerApi.md#removeCustomerById) | **DELETE** /tenants/{tenantId}/customers/{customerId} | Delete customer resource by id
*WorkEvolveApi.CustomerApi* | [**saveCustomer**](docs/CustomerApi.md#saveCustomer) | **POST** /tenants/{tenantId}/customers | Save a new customer resource
*WorkEvolveApi.CustomerApi* | [**updateCustomer**](docs/CustomerApi.md#updateCustomer) | **POST** /tenants/{tenantId}/customers/{customerId} | Update customer resource by id
*WorkEvolveApi.DataRevisionApi* | [**getAllEvents**](docs/DataRevisionApi.md#getAllEvents) | **GET** /tenants/{tenantId}/events | Get all events
*WorkEvolveApi.DataRevisionApi* | [**getDataByEvent**](docs/DataRevisionApi.md#getDataByEvent) | **GET** /tenants/{tenantId}/events/{event} | Get data by specific event
*WorkEvolveApi.DataRevisionApi* | [**getDataByRevision**](docs/DataRevisionApi.md#getDataByRevision) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/revisions/{revision} | Get data of an item by specific revision
*WorkEvolveApi.DataRevisionApi* | [**getDataFromAllRevisions**](docs/DataRevisionApi.md#getDataFromAllRevisions) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/revisions | Get data of an item from all revisions
*WorkEvolveApi.DataRevisionApi* | [**getDataRevisionGroupByVersionNo**](docs/DataRevisionApi.md#getDataRevisionGroupByVersionNo) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/revisions/get | Get data of an item from all revisions that group by revision No
*WorkEvolveApi.DataRevisionApi* | [**getDifferencesByRevision**](docs/DataRevisionApi.md#getDifferencesByRevision) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/revisions/{revisionFrom}/{revisionTo} | Get the difference in fields values between the two revisions
*WorkEvolveApi.DataRevisionApi* | [**revertDataByEvent**](docs/DataRevisionApi.md#revertDataByEvent) | **POST** /tenants/{tenantId}/events/{event}/revert | Reverts the item to the values in the given event. This will undo any changes made after the given event.
*WorkEvolveApi.DataRevisionApi* | [**revertDataByRevision**](docs/DataRevisionApi.md#revertDataByRevision) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/revisions/{revision}/revert | Reverts the item to the values in the given revision. This will undo any changes made after the given revision.
*WorkEvolveApi.FileApi* | [**getAllFile**](docs/FileApi.md#getAllFile) | **POST** /tenants/{tenantId}/files/get | Get all file resource
*WorkEvolveApi.FileApi* | [**getFileBreadCrumbs**](docs/FileApi.md#getFileBreadCrumbs) | **GET** /tenants/{tenantId}/files/{fileId}/breadcrumbs | Get breadcrumbs of file
*WorkEvolveApi.FileApi* | [**getOneFile**](docs/FileApi.md#getOneFile) | **GET** /tenants/{tenantId}/files/{fileId} | Get a file resource by id
*WorkEvolveApi.FileApi* | [**saveFile**](docs/FileApi.md#saveFile) | **POST** /tenants/{tenantId}/files | Save a new file resource
*WorkEvolveApi.FormApi* | [**getAllForms**](docs/FormApi.md#getAllForms) | **POST** /programs/{proId}/forms/get | Get all forms resource
*WorkEvolveApi.FormApi* | [**getFormById**](docs/FormApi.md#getFormById) | **GET** /programs/{proId}/forms/{formId} | Get a form resource by id
*WorkEvolveApi.FormApi* | [**removeFormById**](docs/FormApi.md#removeFormById) | **DELETE** /programs/{proId}/forms/{formId} | Delete form resource by id
*WorkEvolveApi.FormApi* | [**saveForm**](docs/FormApi.md#saveForm) | **POST** /programs/{proId}/forms | Save a new form resource
*WorkEvolveApi.FormApi* | [**updateForm**](docs/FormApi.md#updateForm) | **POST** /programs/{proId}/forms/{formId} | Update form resource by id
*WorkEvolveApi.GroupSecurityApi* | [**getAllGroupSecurities**](docs/GroupSecurityApi.md#getAllGroupSecurities) | **POST** /tenants/{tenantId}/groupsecurity/get | Get all group securities resource
*WorkEvolveApi.GroupSecurityApi* | [**getGroupSecurityById**](docs/GroupSecurityApi.md#getGroupSecurityById) | **GET** /tenants/{tenantId}/groupsecurity/{groupId} | Get a group security resource by id
*WorkEvolveApi.GroupSecurityApi* | [**removeGroupSecurityById**](docs/GroupSecurityApi.md#removeGroupSecurityById) | **DELETE** /tenants/{tenantId}/groupsecurity/{groupId} | Delete group security resource by id
*WorkEvolveApi.GroupSecurityApi* | [**saveGroupSecurity**](docs/GroupSecurityApi.md#saveGroupSecurity) | **POST** /tenants/{tenantId}/groupsecurity | Save a new group security resource
*WorkEvolveApi.GroupSecurityApi* | [**updateGroupSecurity**](docs/GroupSecurityApi.md#updateGroupSecurity) | **POST** /tenants/{tenantId}/groupsecurity/{groupId} | Update group security resource by id
*WorkEvolveApi.InvitationApi* | [**acceptInvitation**](docs/InvitationApi.md#acceptInvitation) | **POST** /invitations/{tokenId}/accept | Accept an invitation resource
*WorkEvolveApi.InvitationApi* | [**getInvitationByTokenId**](docs/InvitationApi.md#getInvitationByTokenId) | **GET** /invitations/{tokenId}/get | Get an invitation resource by token id
*WorkEvolveApi.InvitationApi* | [**reSendInvitation**](docs/InvitationApi.md#reSendInvitation) | **POST** /invitations/{userId} | Resend an invitation resource
*WorkEvolveApi.InvitationApi* | [**removeInvitation**](docs/InvitationApi.md#removeInvitation) | **DELETE** /invitations/{userId} | Remove an invitation resource
*WorkEvolveApi.InvitationApi* | [**sendInvitation**](docs/InvitationApi.md#sendInvitation) | **POST** /invitations | Send a new invitation resource
*WorkEvolveApi.LookupApi* | [**getLookups**](docs/LookupApi.md#getLookups) | **POST** /tenants/{tenantId}/lookup | Get datasources resource
*WorkEvolveApi.MenuApi* | [**getAllMenus**](docs/MenuApi.md#getAllMenus) | **POST** /tenants/{tenantId}/menus/get | Get all menus resource
*WorkEvolveApi.MenuApi* | [**getMenuById**](docs/MenuApi.md#getMenuById) | **GET** /tenants/{tenantId}/menus/{menuId} | Get a menu resource by id
*WorkEvolveApi.MenuApi* | [**getUserMenus**](docs/MenuApi.md#getUserMenus) | **POST** /tenants/{tenantId}/usermenus | Get user menus resource
*WorkEvolveApi.MenuApi* | [**removeMenuById**](docs/MenuApi.md#removeMenuById) | **DELETE** /tenants/{tenantId}/menus/{menuId} | Delete menu resource by id
*WorkEvolveApi.MenuApi* | [**saveMenu**](docs/MenuApi.md#saveMenu) | **POST** /tenants/{tenantId}/menus | Save a new menu resource
*WorkEvolveApi.MenuApi* | [**updateBatchMenu**](docs/MenuApi.md#updateBatchMenu) | **POST** /tenants/{tenantId}/menus/batch | update batch of Menu
*WorkEvolveApi.MenuApi* | [**updateMenu**](docs/MenuApi.md#updateMenu) | **POST** /tenants/{tenantId}/menus/{menuId} | Update menu resource by id
*WorkEvolveApi.MenuSelectionApi* | [**getAllMenuSelections**](docs/MenuSelectionApi.md#getAllMenuSelections) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections/get | Get all menu selections resource
*WorkEvolveApi.MenuSelectionApi* | [**removeMenuSelectionById**](docs/MenuSelectionApi.md#removeMenuSelectionById) | **DELETE** /tenants/{tenantId}/menus/{menuId}/menuselections/{selectionId} | Delete menu selection resource by id
*WorkEvolveApi.MenuSelectionApi* | [**saveMenuSelection**](docs/MenuSelectionApi.md#saveMenuSelection) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections | Save a new menu selection resource
*WorkEvolveApi.MenuSelectionApi* | [**updateBatchMenuSelection**](docs/MenuSelectionApi.md#updateBatchMenuSelection) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections/batch | update batch of MenuSelection
*WorkEvolveApi.MenuSelectionApi* | [**updateMenuSelection**](docs/MenuSelectionApi.md#updateMenuSelection) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections/{selectionId} | Update menu selection resource by id
*WorkEvolveApi.ObjectLibraryApi* | [**getAllObjectLibraries**](docs/ObjectLibraryApi.md#getAllObjectLibraries) | **POST** /objectlibraries/get | Get all object libraries resource
*WorkEvolveApi.ObjectLibraryApi* | [**getObjectLibraryById**](docs/ObjectLibraryApi.md#getObjectLibraryById) | **GET** /objectlibraries/{objId} | Get an object library resource by id
*WorkEvolveApi.ObjectLibraryApi* | [**removeObjectLibraryById**](docs/ObjectLibraryApi.md#removeObjectLibraryById) | **DELETE** /objectlibraries/{objId} | Delete object library resource by id
*WorkEvolveApi.ObjectLibraryApi* | [**saveObjectLibrary**](docs/ObjectLibraryApi.md#saveObjectLibrary) | **POST** /objectlibraries | Save a new object library resource
*WorkEvolveApi.ObjectLibraryApi* | [**updateBatchObjectLibrary**](docs/ObjectLibraryApi.md#updateBatchObjectLibrary) | **POST** /objectlibraries/batch | update batch of ObjectLibrary
*WorkEvolveApi.ObjectLibraryApi* | [**updateObjectLibrary**](docs/ObjectLibraryApi.md#updateObjectLibrary) | **POST** /objectlibraries/{objId} | Update object library resource by id
*WorkEvolveApi.PostApi* | [**getAllPosts**](docs/PostApi.md#getAllPosts) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/get | Get all posts resource
*WorkEvolveApi.PostApi* | [**getPostById**](docs/PostApi.md#getPostById) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId} | Get a post resource by id
*WorkEvolveApi.PostApi* | [**savePost**](docs/PostApi.md#savePost) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts | Save a new post resource
*WorkEvolveApi.PostApi* | [**updatePost**](docs/PostApi.md#updatePost) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId} | Update post resource by id
*WorkEvolveApi.ProgramApi* | [**getAllPrograms**](docs/ProgramApi.md#getAllPrograms) | **POST** /programs/get | Get all programs resource
*WorkEvolveApi.ProgramApi* | [**getProgramById**](docs/ProgramApi.md#getProgramById) | **GET** /programs/{proId} | Get a program resource by id
*WorkEvolveApi.ProgramApi* | [**removeProgramById**](docs/ProgramApi.md#removeProgramById) | **DELETE** /programs/{proId} | Delete program resource by id
*WorkEvolveApi.ProgramApi* | [**saveProgram**](docs/ProgramApi.md#saveProgram) | **POST** /programs | Save a new program resource
*WorkEvolveApi.ProgramApi* | [**updateProgram**](docs/ProgramApi.md#updateProgram) | **POST** /programs/{proId} | Update program resource by id
*WorkEvolveApi.ProjectApi* | [**getAllProjects**](docs/ProjectApi.md#getAllProjects) | **POST** /tenants/{tenantId}/projects/get | Get all projects resource
*WorkEvolveApi.ProjectApi* | [**getProjectById**](docs/ProjectApi.md#getProjectById) | **GET** /tenants/{tenantId}/projects/{projectId} | Get a project resource by id
*WorkEvolveApi.ProjectApi* | [**saveProject**](docs/ProjectApi.md#saveProject) | **POST** /tenants/{tenantId}/projects | Save a new project resource
*WorkEvolveApi.ProjectApi* | [**updateProject**](docs/ProjectApi.md#updateProject) | **POST** /tenants/{tenantId}/projects/{projectId} | Update project resource by id
*WorkEvolveApi.RatingApi* | [**getRatingByUserId**](docs/RatingApi.md#getRatingByUserId) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/ratings/{userId} | Get a rating resource by user id
*WorkEvolveApi.RatingApi* | [**saveRating**](docs/RatingApi.md#saveRating) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/ratings | Save a new rating resource
*WorkEvolveApi.RatingApi* | [**updateRatingByUserId**](docs/RatingApi.md#updateRatingByUserId) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/ratings/{userId} | Update rating resource by user id
*WorkEvolveApi.ReactionApi* | [**getAllReactions**](docs/ReactionApi.md#getAllReactions) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/reactions/get | Get all reactions resource
*WorkEvolveApi.ReactionApi* | [**getReactionById**](docs/ReactionApi.md#getReactionById) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/reactions/{reactionId} | Get a reaction resource by id
*WorkEvolveApi.ReactionApi* | [**removeReactoinById**](docs/ReactionApi.md#removeReactoinById) | **DELETE** /tenants/{tenantId}/{resource}/{resourceId}/reactions/{reactionId} | Delete reaction resource by id
*WorkEvolveApi.ReactionApi* | [**saveReaction**](docs/ReactionApi.md#saveReaction) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/reactions | Save a new reaction resource
*WorkEvolveApi.ReactionApi* | [**updateReaction**](docs/ReactionApi.md#updateReaction) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/reactions/{reactionId} | Update reaction resource by id
*WorkEvolveApi.ReplyApi* | [**getAllReplies**](docs/ReplyApi.md#getAllReplies) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/get | Get all replies resource
*WorkEvolveApi.ReplyApi* | [**getReplyById**](docs/ReplyApi.md#getReplyById) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId} | Get a reply resource by id
*WorkEvolveApi.ReplyApi* | [**saveReply**](docs/ReplyApi.md#saveReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies | Save a new reply resource
*WorkEvolveApi.ReplyApi* | [**updateReply**](docs/ReplyApi.md#updateReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId} | Update reply resource by id
*WorkEvolveApi.ReplyOfReplyApi* | [**getAllRepliesOfReply**](docs/ReplyOfReplyApi.md#getAllRepliesOfReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/get | Get all replies of reply resource
*WorkEvolveApi.ReplyOfReplyApi* | [**getReplyOfReplyById**](docs/ReplyOfReplyApi.md#getReplyOfReplyById) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/{replyLevel2Id} | Get a reply of reply resource by id
*WorkEvolveApi.ReplyOfReplyApi* | [**saveReplyOfReply**](docs/ReplyOfReplyApi.md#saveReplyOfReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies | Save a new reply of reply resource
*WorkEvolveApi.ReplyOfReplyApi* | [**updateReplyOfReply**](docs/ReplyOfReplyApi.md#updateReplyOfReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/{replyLevel2Id} | Update reply of reply resource by id
*WorkEvolveApi.RoleApi* | [**getAllRoles**](docs/RoleApi.md#getAllRoles) | **POST** /tenants/{tenantId}/roles/get | Get all roles resource
*WorkEvolveApi.RoleApi* | [**getRoleById**](docs/RoleApi.md#getRoleById) | **GET** /tenants/{tenantId}/roles/{role} | Get a role resource by id
*WorkEvolveApi.RoleApi* | [**removeRoleById**](docs/RoleApi.md#removeRoleById) | **DELETE** /tenants/{tenantId}/roles/{role} | Delete role resource by id
*WorkEvolveApi.RoleApi* | [**saveRole**](docs/RoleApi.md#saveRole) | **POST** /tenants/{tenantId}/roles | Save a new role resource
*WorkEvolveApi.RoleApi* | [**updateBatchRole**](docs/RoleApi.md#updateBatchRole) | **POST** /tenants/{tenantId}/roles/batch | update batch of role
*WorkEvolveApi.RoleApi* | [**updateRole**](docs/RoleApi.md#updateRole) | **POST** /tenants/{tenantId}/roles/{role} | Update role resource by id
*WorkEvolveApi.RoleLibraryApi* | [**getAllRoleLibraries**](docs/RoleLibraryApi.md#getAllRoleLibraries) | **POST** /tenants/{tenantId}/rolelibraries/get | Get all role libraries resource
*WorkEvolveApi.RoleLibraryApi* | [**getRoleLibraryById**](docs/RoleLibraryApi.md#getRoleLibraryById) | **GET** /tenants/{tenantId}/rolelibraries/{role} | Get a role library resource by id
*WorkEvolveApi.RoleLibraryApi* | [**removeRoleLibraryById**](docs/RoleLibraryApi.md#removeRoleLibraryById) | **DELETE** /tenants/{tenantId}/rolelibraries/{role} | Delete role library resource by id
*WorkEvolveApi.RoleLibraryApi* | [**saveRoleLibrary**](docs/RoleLibraryApi.md#saveRoleLibrary) | **POST** /tenants/{tenantId}/rolelibraries | Save a new role library resource
*WorkEvolveApi.RoleLibraryApi* | [**updateRoleLibrary**](docs/RoleLibraryApi.md#updateRoleLibrary) | **POST** /tenants/{tenantId}/rolelibraries/{role} | Update role library resource by id
*WorkEvolveApi.RowPermissionApi* | [**getAllRowPermissions**](docs/RowPermissionApi.md#getAllRowPermissions) | **POST** /tenants/{tenantId}/roles/{role}/rowpermission/get | Get all row permissions resource
*WorkEvolveApi.RowPermissionApi* | [**getRowPermissionById**](docs/RowPermissionApi.md#getRowPermissionById) | **GET** /tenants/{tenantId}/roles/{role}/rowpermission/{permissionId} | Get a row permission resource by id
*WorkEvolveApi.RowPermissionApi* | [**removeRowPermissionById**](docs/RowPermissionApi.md#removeRowPermissionById) | **DELETE** /tenants/{tenantId}/roles/{role}/rowpermission/{permissionId} | Delete row permission resource by id
*WorkEvolveApi.RowPermissionApi* | [**saveRowPermission**](docs/RowPermissionApi.md#saveRowPermission) | **POST** /tenants/{tenantId}/roles/{role}/rowpermission | Save a new row permission resource
*WorkEvolveApi.RowPermissionApi* | [**updateBatchRowPermission**](docs/RowPermissionApi.md#updateBatchRowPermission) | **POST** /tenants/{tenantId}/rowpermission/batch | update batch of RowPermission
*WorkEvolveApi.RowPermissionApi* | [**updateRowPermission**](docs/RowPermissionApi.md#updateRowPermission) | **POST** /tenants/{tenantId}/roles/{role}/rowpermission/{permissionId} | Update row permission resource by id
*WorkEvolveApi.SampleApi* | [**getSample**](docs/SampleApi.md#getSample) | **GET** /sample | Sample
*WorkEvolveApi.SchemaApi* | [**getAllSchemas**](docs/SchemaApi.md#getAllSchemas) | **POST** /schemas/get | Get all schemas resource
*WorkEvolveApi.SchemaApi* | [**getDistinctSchema**](docs/SchemaApi.md#getDistinctSchema) | **POST** /tenants/{tenantId}/distinct-schema/get | get distinct schema records by datasource
*WorkEvolveApi.SchemaApi* | [**getSchemaById**](docs/SchemaApi.md#getSchemaById) | **GET** /schemas/{schemaId} | Get a schema resource by id
*WorkEvolveApi.SchemaApi* | [**removeSchemaById**](docs/SchemaApi.md#removeSchemaById) | **DELETE** /schemas/{schemaId} | Delete schema resource by id
*WorkEvolveApi.SchemaApi* | [**saveSchema**](docs/SchemaApi.md#saveSchema) | **POST** /schemas | Save a new schema resource
*WorkEvolveApi.SchemaApi* | [**updateSchema**](docs/SchemaApi.md#updateSchema) | **POST** /schemas/{schemaId} | Update schema resource by id
*WorkEvolveApi.TaskApi* | [**getAllTasks**](docs/TaskApi.md#getAllTasks) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/tasks/get | Get all tasks resource
*WorkEvolveApi.TaskApi* | [**getTaskById**](docs/TaskApi.md#getTaskById) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/tasks/{taskId} | Get a task resource by id
*WorkEvolveApi.TaskApi* | [**removeTaskById**](docs/TaskApi.md#removeTaskById) | **DELETE** /tenants/{tenantId}/{resource}/{resourceId}/tasks/{taskId} | Delete task resource by id
*WorkEvolveApi.TaskApi* | [**saveTask**](docs/TaskApi.md#saveTask) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/tasks | Save a new task resource
*WorkEvolveApi.TaskApi* | [**updateTask**](docs/TaskApi.md#updateTask) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/tasks/{taskId} | Update task resource by id
*WorkEvolveApi.TenantApi* | [**addPaymentMethod**](docs/TenantApi.md#addPaymentMethod) | **POST** /tenants/{tenantId}/paymentmethods | Add a new payment method resource
*WorkEvolveApi.TenantApi* | [**changeSubscriptionPlan**](docs/TenantApi.md#changeSubscriptionPlan) | **POST** /tenants/{tenantId}/subscription/swap | Change plan of subscription resource
*WorkEvolveApi.TenantApi* | [**checkSubscriptionStatus**](docs/TenantApi.md#checkSubscriptionStatus) | **GET** /tenants/{tenantId}/subscription/status | Check status of subscription resource
*WorkEvolveApi.TenantApi* | [**downloadInvoice**](docs/TenantApi.md#downloadInvoice) | **POST** /tenants/{tenantId}/billing/download | Download billing invoice resource
*WorkEvolveApi.TenantApi* | [**getBilling**](docs/TenantApi.md#getBilling) | **POST** /tenants/{tenantId}/billing/get | Get billing information resource
*WorkEvolveApi.TenantApi* | [**getPaymentMethods**](docs/TenantApi.md#getPaymentMethods) | **POST** /tenants/{tenantId}/paymentmethods/get | Get payment methods resource
*WorkEvolveApi.TenantApi* | [**getTenantById**](docs/TenantApi.md#getTenantById) | **GET** /tenants/{tenantId} | Get an tenant resource by id
*WorkEvolveApi.TenantApi* | [**makeDefaultPaymentMethod**](docs/TenantApi.md#makeDefaultPaymentMethod) | **POST** /tenants/{tenantId}/paymentmethods/{cardId} | Make default payment method resource
*WorkEvolveApi.TenantApi* | [**registerTenant**](docs/TenantApi.md#registerTenant) | **POST** /tenants/register | register a new tenant resource
*WorkEvolveApi.TenantApi* | [**removePaymentMethod**](docs/TenantApi.md#removePaymentMethod) | **DELETE** /tenants/{tenantId}/paymentmethods/{cardId} | Remove a new payment method resource
*WorkEvolveApi.TenantApi* | [**subscribePlan**](docs/TenantApi.md#subscribePlan) | **POST** /tenants/{tenantId}/subscription | Subscribe a new pricing plan resource
*WorkEvolveApi.TenantApi* | [**updatePaymentMethod**](docs/TenantApi.md#updatePaymentMethod) | **POST** /tenants/{tenantId}/paymentmethods/{cardId}/update | Update payment method resource
*WorkEvolveApi.TenantApi* | [**updateTenant**](docs/TenantApi.md#updateTenant) | **POST** /tenants/{tenantId}/update | Update tenant resource by id
*WorkEvolveApi.UdcTypeApi* | [**getAllUdcTypes**](docs/UdcTypeApi.md#getAllUdcTypes) | **POST** /systems/{sysCode}/types/get | Get all udc types resource without tenant
*WorkEvolveApi.UdcTypeApi* | [**getAllUdcTypesTenant**](docs/UdcTypeApi.md#getAllUdcTypesTenant) | **POST** /tenants/{tenantId}/systems/{sysCode}/types/get | Get all udc types resource with tenant
*WorkEvolveApi.UdcTypeApi* | [**getUdcTypeById**](docs/UdcTypeApi.md#getUdcTypeById) | **GET** /systems/{sysCode}/types/{typeId} | Get a udc type without tenant resource by id
*WorkEvolveApi.UdcTypeApi* | [**getUdcTypeTenantById**](docs/UdcTypeApi.md#getUdcTypeTenantById) | **GET** /tenants/{tenantId}/systems/{sysCode}/types/{typeId} | Get a udc type with tenant resource by id
*WorkEvolveApi.UdcTypeApi* | [**removeUdcTypeById**](docs/UdcTypeApi.md#removeUdcTypeById) | **DELETE** /systems/{sysCode}/types/{typeId} | Delete udc type resource without tenant by id
*WorkEvolveApi.UdcTypeApi* | [**removeUdcTypeTenantById**](docs/UdcTypeApi.md#removeUdcTypeTenantById) | **DELETE** /tenants/{tenantId}/systems/{sysCode}/types/{typeId} | Delete udc type resource with tenant by id
*WorkEvolveApi.UdcTypeApi* | [**saveUdcType**](docs/UdcTypeApi.md#saveUdcType) | **POST** /systems/{sysCode}/types | Save a new udc type resource without tenant
*WorkEvolveApi.UdcTypeApi* | [**saveUdcTypeTenant**](docs/UdcTypeApi.md#saveUdcTypeTenant) | **POST** /tenants/{tenantId}/systems/{sysCode}/types | Save a new udc type resource with tenant
*WorkEvolveApi.UdcTypeApi* | [**updateUdcTenantType**](docs/UdcTypeApi.md#updateUdcTenantType) | **POST** /tenants/{tenantId}/systems/{sysCode}/types/{typeId} | Update udc type resource with tenant by id
*WorkEvolveApi.UdcTypeApi* | [**updateUdcType**](docs/UdcTypeApi.md#updateUdcType) | **POST** /systems/{sysCode}/types/{typeId} | Update udc type resource with tenantout by id
*WorkEvolveApi.UdcValueApi* | [**getAllUdcValues**](docs/UdcValueApi.md#getAllUdcValues) | **POST** /systems/{sysCode}/types/{typeId}/values/get | Get all udc values resource without tenant
*WorkEvolveApi.UdcValueApi* | [**getAllUdcValuesTenant**](docs/UdcValueApi.md#getAllUdcValuesTenant) | **POST** /tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/get | Get all udc values resource with tenant
*WorkEvolveApi.UdcValueApi* | [**getUdcValueById**](docs/UdcValueApi.md#getUdcValueById) | **GET** /systems/{sysCode}/types/{typeId}/values/{valueId} | Get udc value resource without tenant by id
*WorkEvolveApi.UdcValueApi* | [**getUdcValueTenantById**](docs/UdcValueApi.md#getUdcValueTenantById) | **GET** /tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/{valueId} | Get udc value resource with tenant by id
*WorkEvolveApi.UdcValueApi* | [**removeUdcValueById**](docs/UdcValueApi.md#removeUdcValueById) | **DELETE** /systems/{sysCode}/types/{typeId}/values/{valueId} | Delete udc value resource without tenant by id
*WorkEvolveApi.UdcValueApi* | [**removeUdcValueTenantById**](docs/UdcValueApi.md#removeUdcValueTenantById) | **DELETE** /tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/{valueId} | Delete udc value resource with tenant by id
*WorkEvolveApi.UdcValueApi* | [**saveUdcValue**](docs/UdcValueApi.md#saveUdcValue) | **POST** /systems/{sysCode}/types/{typeId}/values | Save a new udc value resource without tenant
*WorkEvolveApi.UdcValueApi* | [**saveUdcValueTenant**](docs/UdcValueApi.md#saveUdcValueTenant) | **POST** /tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values | Save a new udc value resource with tenant
*WorkEvolveApi.UdcValueApi* | [**updateUdcValue**](docs/UdcValueApi.md#updateUdcValue) | **POST** /systems/{sysCode}/types/{typeId}/values/{valueId} | Update udc value resource without tenant by id
*WorkEvolveApi.UdcValueApi* | [**updateUdcValueTenant**](docs/UdcValueApi.md#updateUdcValueTenant) | **POST** /tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/{valueId} | Update udc value resource with tenant by id
*WorkEvolveApi.UploadApi* | [**removeUploadFile**](docs/UploadApi.md#removeUploadFile) | **DELETE** /tenants/{tenantId}/upload/{fileId} | Remove an uploaded file resource
*WorkEvolveApi.UploadApi* | [**uploadFile**](docs/UploadApi.md#uploadFile) | **POST** /tenants/{tenantId}/upload | Upload a new file resource
*WorkEvolveApi.UserApi* | [**getAllUsers**](docs/UserApi.md#getAllUsers) | **POST** /users/get | Get all users resource
*WorkEvolveApi.UserApi* | [**getUserById**](docs/UserApi.md#getUserById) | **GET** /users/{userId} | Get a user resource by id
*WorkEvolveApi.UserApi* | [**updateUser**](docs/UserApi.md#updateUser) | **POST** /users/{userId} | Update user resource by id
*WorkEvolveApi.UserRoleApi* | [**getAllUserRoles**](docs/UserRoleApi.md#getAllUserRoles) | **POST** /tenants/{tenantId}/userroles/get | Get all user roles resource
*WorkEvolveApi.UserRoleApi* | [**getUserRoleById**](docs/UserRoleApi.md#getUserRoleById) | **GET** /tenants/{tenantId}/userroles/{userRole} | Get a user role resource by id
*WorkEvolveApi.UserRoleApi* | [**removeUserRoleById**](docs/UserRoleApi.md#removeUserRoleById) | **DELETE** /tenants/{tenantId}/userroles/{userRole} | Delete user role resource by id
*WorkEvolveApi.UserRoleApi* | [**saveUserRole**](docs/UserRoleApi.md#saveUserRole) | **POST** /tenants/{tenantId}/userroles | Save a new user role resource
*WorkEvolveApi.UserRoleApi* | [**updateUserRole**](docs/UserRoleApi.md#updateUserRole) | **POST** /tenants/{tenantId}/userroles/{userRole} | Update user role resource by id
*WorkEvolveApi.UserSecurityApi* | [**getAllUserSecurities**](docs/UserSecurityApi.md#getAllUserSecurities) | **POST** /tenants/{tenantId}/usersecurity/get | Get all user securities resource
*WorkEvolveApi.UserSecurityApi* | [**getUserSecurityById**](docs/UserSecurityApi.md#getUserSecurityById) | **GET** /tenants/{tenantId}/usersecurity/{userSecurityId} | Get a user security resource by id
*WorkEvolveApi.UserSecurityApi* | [**removeUserSecurityById**](docs/UserSecurityApi.md#removeUserSecurityById) | **DELETE** /tenants/{tenantId}/usersecurity/{userSecurityId} | Delete user security resource by id
*WorkEvolveApi.UserSecurityApi* | [**saveUserSecurity**](docs/UserSecurityApi.md#saveUserSecurity) | **POST** /tenants/{tenantId}/usersecurity | Save a new user security resource
*WorkEvolveApi.UserSecurityApi* | [**updateUserSecurity**](docs/UserSecurityApi.md#updateUserSecurity) | **POST** /tenants/{tenantId}/usersecurity/{userSecurityId} | Update user security resource by id
*WorkEvolveApi.VersionApi* | [**getAllVersions**](docs/VersionApi.md#getAllVersions) | **POST** /tenants/{tenantId}/programs/{proId}/versions/get | Get all versions resource
*WorkEvolveApi.VersionApi* | [**getVersionById**](docs/VersionApi.md#getVersionById) | **GET** /tenants/{tenantId}/programs/{proId}/versions/{versionId} | Get a version resource by id
*WorkEvolveApi.VersionApi* | [**removeVersionById**](docs/VersionApi.md#removeVersionById) | **DELETE** /tenants/{tenantId}/programs/{proId}/versions/{versionId} | Delete version resource by id
*WorkEvolveApi.VersionApi* | [**saveVersion**](docs/VersionApi.md#saveVersion) | **POST** /tenants/{tenantId}/programs/{proId}/versions | Save a new version resource
*WorkEvolveApi.VersionApi* | [**updateVersion**](docs/VersionApi.md#updateVersion) | **POST** /tenants/{tenantId}/programs/{proId}/versions/{versionId} | Update version resource by id


## Documentation for Models



## Documentation for Authorization


### default

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

