# WorkEvolveApi.ActionPermissionApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getActionPermissionById**](ActionPermissionApi.md#getActionPermissionById) | **GET** /tenants/{tenantId}/roles/{role}/actionpermission/{permissionId} | Get an action permission resource by id
[**getAllActionPermissions**](ActionPermissionApi.md#getAllActionPermissions) | **POST** /tenants/{tenantId}/roles/{role}/actionpermission/get | Get all action permissions resource
[**removeActionPermissionById**](ActionPermissionApi.md#removeActionPermissionById) | **DELETE** /tenants/{tenantId}/roles/{role}/actionpermission/{permissionId} | Delete action permission resource by id
[**saveActionPermission**](ActionPermissionApi.md#saveActionPermission) | **POST** /tenants/{tenantId}/roles/{role}/actionpermission | Save a new action permission resource
[**updateActionPermission**](ActionPermissionApi.md#updateActionPermission) | **POST** /tenants/{tenantId}/roles/{role}/actionpermission/{permissionId} | Update action permission resource by id


<a name="getActionPermissionById"></a>
# **getActionPermissionById**
> getActionPermissionById(tenantId, role, permissionId)

Get an action permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ActionPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | Id of action permission to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getActionPermissionById(tenantId, role, permissionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| Id of action permission to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getAllActionPermissions"></a>
# **getAllActionPermissions**
> getAllActionPermissions(tenantId, role, opts)

Get all action permissions resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ActionPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var opts = { 
  'filter': null, // Object | Filter action permissions by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllActionPermissions(tenantId, role, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **filter** | **Object**| Filter action permissions by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeActionPermissionById"></a>
# **removeActionPermissionById**
> removeActionPermissionById(tenantId, role, permissionId)

Delete action permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ActionPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | ID of action permission to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeActionPermissionById(tenantId, role, permissionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| ID of action permission to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveActionPermission"></a>
# **saveActionPermission**
> saveActionPermission(tenantId, role, data)

Save a new action permission resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ActionPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var data = null; // Object | Provide your action permission data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveActionPermission(tenantId, role, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **data** | **Object**| Provide your action permission data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateActionPermission"></a>
# **updateActionPermission**
> updateActionPermission(tenantId, role, permissionId, data)

Update action permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ActionPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | ID of action permission to filter by

var data = null; // Object | Provide your action permission data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateActionPermission(tenantId, role, permissionId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| ID of action permission to filter by | 
 **data** | **Object**| Provide your action permission data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

