# WorkEvolveApi.ApplicationPermissionApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllApplicationPermissions**](ApplicationPermissionApi.md#getAllApplicationPermissions) | **POST** /tenants/{tenantId}/roles/{role}/applicationpermission/get | Get all application permissions resource
[**getApplicationPermissionById**](ApplicationPermissionApi.md#getApplicationPermissionById) | **GET** /tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId} | Get an application permission resource by id
[**removeApplicationPermissionById**](ApplicationPermissionApi.md#removeApplicationPermissionById) | **DELETE** /tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId} | Delete application permission resource by id
[**saveApplicationPermission**](ApplicationPermissionApi.md#saveApplicationPermission) | **POST** /tenants/{tenantId}/roles/{role}/applicationpermission | Save a new application permission resource
[**updateApplicationPermission**](ApplicationPermissionApi.md#updateApplicationPermission) | **POST** /tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId} | Update application permission resource by id


<a name="getAllApplicationPermissions"></a>
# **getAllApplicationPermissions**
> getAllApplicationPermissions(tenantId, role, opts)

Get all application permissions resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ApplicationPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var opts = { 
  'filter': null, // Object | Filter application permissions by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllApplicationPermissions(tenantId, role, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **filter** | **Object**| Filter application permissions by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getApplicationPermissionById"></a>
# **getApplicationPermissionById**
> getApplicationPermissionById(tenantId, role, permissionId)

Get an application permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ApplicationPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | Id of application permission to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getApplicationPermissionById(tenantId, role, permissionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| Id of application permission to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeApplicationPermissionById"></a>
# **removeApplicationPermissionById**
> removeApplicationPermissionById(tenantId, role, permissionId)

Delete application permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ApplicationPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | ID of application permission to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeApplicationPermissionById(tenantId, role, permissionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| ID of application permission to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveApplicationPermission"></a>
# **saveApplicationPermission**
> saveApplicationPermission(tenantId, role, data)

Save a new application permission resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ApplicationPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var data = null; // Object | Provide your application permission data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveApplicationPermission(tenantId, role, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **data** | **Object**| Provide your application permission data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateApplicationPermission"></a>
# **updateApplicationPermission**
> updateApplicationPermission(tenantId, role, permissionId, data)

Update application permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ApplicationPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | ID of application permission to filter by

var data = null; // Object | Provide your application permission data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateApplicationPermission(tenantId, role, permissionId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| ID of application permission to filter by | 
 **data** | **Object**| Provide your application permission data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

