# WorkEvolveApi.ColumnPermissionApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllColumnPermissions**](ColumnPermissionApi.md#getAllColumnPermissions) | **POST** /tenants/{tenantId}/roles/{role}/columnpermission/get | Get all column permissions resource
[**getColumnPermissionById**](ColumnPermissionApi.md#getColumnPermissionById) | **GET** /tenants/{tenantId}/roles/{role}/columnpermission/{permissionId} | Get a column permission resource by id
[**removeColumnPermissionById**](ColumnPermissionApi.md#removeColumnPermissionById) | **DELETE** /tenants/{tenantId}/roles/{role}/columnpermission/{permissionId} | Delete column permission resource by id
[**saveColumnPermission**](ColumnPermissionApi.md#saveColumnPermission) | **POST** /tenants/{tenantId}/roles/{role}/columnpermission | Save a new column permission resource
[**updateColumnPermission**](ColumnPermissionApi.md#updateColumnPermission) | **POST** /tenants/{tenantId}/roles/{role}/columnpermission/{permissionId} | Update column permission resource by id


<a name="getAllColumnPermissions"></a>
# **getAllColumnPermissions**
> getAllColumnPermissions(tenantId, role, opts)

Get all column permissions resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ColumnPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var opts = { 
  'filter': null, // Object | Filter column permissions by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllColumnPermissions(tenantId, role, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **filter** | **Object**| Filter column permissions by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getColumnPermissionById"></a>
# **getColumnPermissionById**
> getColumnPermissionById(tenantId, role, permissionId)

Get a column permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ColumnPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | Id of column permission to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getColumnPermissionById(tenantId, role, permissionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| Id of column permission to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeColumnPermissionById"></a>
# **removeColumnPermissionById**
> removeColumnPermissionById(tenantId, role, permissionId)

Delete column permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ColumnPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | ID of column permission to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeColumnPermissionById(tenantId, role, permissionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| ID of column permission to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveColumnPermission"></a>
# **saveColumnPermission**
> saveColumnPermission(tenantId, role, data)

Save a new column permission resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ColumnPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var data = null; // Object | Provide your column permission data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveColumnPermission(tenantId, role, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **data** | **Object**| Provide your column permission data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateColumnPermission"></a>
# **updateColumnPermission**
> updateColumnPermission(tenantId, role, permissionId, data)

Update column permission resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ColumnPermissionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var role = "role_example"; // String | ID of role to filter by

var permissionId = "permissionId_example"; // String | ID of column permission to filter by

var data = null; // Object | Provide your column permission data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateColumnPermission(tenantId, role, permissionId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **role** | **String**| ID of role to filter by | 
 **permissionId** | **String**| ID of column permission to filter by | 
 **data** | **Object**| Provide your column permission data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

