# WorkEvolveApi.MenuSelectionApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllMenuSelections**](MenuSelectionApi.md#getAllMenuSelections) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections/get | Get all menu selections resource
[**removeMenuSelectionById**](MenuSelectionApi.md#removeMenuSelectionById) | **DELETE** /tenants/{tenantId}/menus/{menuId}/menuselections/{selectionId} | Delete menu selection resource by id
[**saveMenuSelection**](MenuSelectionApi.md#saveMenuSelection) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections | Save a new menu selection resource
[**updateBatchMenuSelection**](MenuSelectionApi.md#updateBatchMenuSelection) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections/batch | update batch of MenuSelection
[**updateMenuSelection**](MenuSelectionApi.md#updateMenuSelection) | **POST** /tenants/{tenantId}/menus/{menuId}/menuselections/{selectionId} | Update menu selection resource by id


<a name="getAllMenuSelections"></a>
# **getAllMenuSelections**
> getAllMenuSelections(tenantId, menuId, opts)

Get all menu selections resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.MenuSelectionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var menuId = "menuId_example"; // String | ID of menu to filter by

var opts = { 
  'filter': null, // Object | Filter menu selections by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllMenuSelections(tenantId, menuId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **menuId** | **String**| ID of menu to filter by | 
 **filter** | **Object**| Filter menu selections by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeMenuSelectionById"></a>
# **removeMenuSelectionById**
> removeMenuSelectionById(tenantId, menuId, selectionId)

Delete menu selection resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.MenuSelectionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var menuId = "menuId_example"; // String | ID of menu to filter by

var selectionId = "selectionId_example"; // String | ID of selection to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeMenuSelectionById(tenantId, menuId, selectionId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **menuId** | **String**| ID of menu to filter by | 
 **selectionId** | **String**| ID of selection to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveMenuSelection"></a>
# **saveMenuSelection**
> saveMenuSelection(tenantId, menuId, data)

Save a new menu selection resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.MenuSelectionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var menuId = "menuId_example"; // String | ID of menu to filter by

var data = null; // Object | Provide your menu selection data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveMenuSelection(tenantId, menuId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **menuId** | **String**| ID of menu to filter by | 
 **data** | **Object**| Provide your menu selection data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateBatchMenuSelection"></a>
# **updateBatchMenuSelection**
> updateBatchMenuSelection(tenantId, menuId, opts)

update batch of MenuSelection

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.MenuSelectionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var menuId = "menuId_example"; // String | ID of menu master to filter by

var opts = { 
  'data': null // Object | Provide your role MenuSelection information to save
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateBatchMenuSelection(tenantId, menuId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **menuId** | **String**| ID of menu master to filter by | 
 **data** | **Object**| Provide your role MenuSelection information to save | [optional] 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateMenuSelection"></a>
# **updateMenuSelection**
> updateMenuSelection(tenantId, menuId, selectionId, data)

Update menu selection resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.MenuSelectionApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var menuId = "menuId_example"; // String | ID of menu to filter by

var selectionId = "selectionId_example"; // String | ID of menu selection to filter by

var data = null; // Object | Provide your menu selection data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateMenuSelection(tenantId, menuId, selectionId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **menuId** | **String**| ID of menu to filter by | 
 **selectionId** | **String**| ID of menu selection to filter by | 
 **data** | **Object**| Provide your menu selection data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

