# WorkEvolveApi.ObjectLibraryApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllObjectLibraries**](ObjectLibraryApi.md#getAllObjectLibraries) | **POST** /objectlibraries/get | Get all object libraries resource
[**getObjectLibraryById**](ObjectLibraryApi.md#getObjectLibraryById) | **GET** /objectlibraries/{objId} | Get an object library resource by id
[**removeObjectLibraryById**](ObjectLibraryApi.md#removeObjectLibraryById) | **DELETE** /objectlibraries/{objId} | Delete object library resource by id
[**saveObjectLibrary**](ObjectLibraryApi.md#saveObjectLibrary) | **POST** /objectlibraries | Save a new object library resource
[**updateBatchObjectLibrary**](ObjectLibraryApi.md#updateBatchObjectLibrary) | **POST** /objectlibraries/batch | update batch of ObjectLibrary
[**updateObjectLibrary**](ObjectLibraryApi.md#updateObjectLibrary) | **POST** /objectlibraries/{objId} | Update object library resource by id


<a name="getAllObjectLibraries"></a>
# **getAllObjectLibraries**
> getAllObjectLibraries(opts)

Get all object libraries resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ObjectLibraryApi();

var opts = { 
  'filter': null, // Object | Filter object libraries by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllObjectLibraries(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **filter** | **Object**| Filter object libraries by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getObjectLibraryById"></a>
# **getObjectLibraryById**
> getObjectLibraryById(objId)

Get an object library resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ObjectLibraryApi();

var objId = "objId_example"; // String | ID of object library to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getObjectLibraryById(objId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **objId** | **String**| ID of object library to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeObjectLibraryById"></a>
# **removeObjectLibraryById**
> removeObjectLibraryById(objId)

Delete object library resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ObjectLibraryApi();

var objId = "objId_example"; // String | ID of object library to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeObjectLibraryById(objId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **objId** | **String**| ID of object library to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveObjectLibrary"></a>
# **saveObjectLibrary**
> saveObjectLibrary(data)

Save a new object library resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ObjectLibraryApi();

var data = null; // Object | Provide your object library data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveObjectLibrary(data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | **Object**| Provide your object library data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateBatchObjectLibrary"></a>
# **updateBatchObjectLibrary**
> updateBatchObjectLibrary(tenantId, opts)

update batch of ObjectLibrary

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ObjectLibraryApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var opts = { 
  'data': null // Object | Provide your ObjectLibrary data information to save
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateBatchObjectLibrary(tenantId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **data** | **Object**| Provide your ObjectLibrary data information to save | [optional] 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateObjectLibrary"></a>
# **updateObjectLibrary**
> updateObjectLibrary(objId, data)

Update object library resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ObjectLibraryApi();

var objId = "objId_example"; // String | ID of object library to filter by

var data = null; // Object | Provide your object library data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateObjectLibrary(objId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **objId** | **String**| ID of object library to filter by | 
 **data** | **Object**| Provide your object library data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

