# WorkEvolveApi.RatingApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getRatingByUserId**](RatingApi.md#getRatingByUserId) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/ratings/{userId} | Get a rating resource by user id
[**saveRating**](RatingApi.md#saveRating) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/ratings | Save a new rating resource
[**updateRatingByUserId**](RatingApi.md#updateRatingByUserId) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/ratings/{userId} | Update rating resource by user id


<a name="getRatingByUserId"></a>
# **getRatingByUserId**
> getRatingByUserId(tenantId, resource, resourceId, userId)

Get a rating resource by user id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.RatingApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var resource = "resource_example"; // String | Name of resource to attach rating

var resourceId = "resourceId_example"; // String | ID of resource to attach rating

var userId = "userId_example"; // String | ID of user to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getRatingByUserId(tenantId, resource, resourceId, userId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **resource** | **String**| Name of resource to attach rating | 
 **resourceId** | **String**| ID of resource to attach rating | 
 **userId** | **String**| ID of user to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveRating"></a>
# **saveRating**
> saveRating(tenantId, resource, resourceId, data)

Save a new rating resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.RatingApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var resource = "resource_example"; // String | Name of resource to attach rating

var resourceId = "resourceId_example"; // String | ID of resource to attach rating

var data = null; // Object | Provide your rating data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveRating(tenantId, resource, resourceId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **resource** | **String**| Name of resource to attach rating | 
 **resourceId** | **String**| ID of resource to attach rating | 
 **data** | **Object**| Provide your rating data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateRatingByUserId"></a>
# **updateRatingByUserId**
> updateRatingByUserId(tenantId, resource, resourceId, userId, data)

Update rating resource by user id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.RatingApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var resource = "resource_example"; // String | Name of resource to attach rating

var resourceId = "resourceId_example"; // String | ID of resource to attach rating

var userId = "userId_example"; // String | ID of user to filter by

var data = null; // Object | Provide your rating data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateRatingByUserId(tenantId, resource, resourceId, userId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **resource** | **String**| Name of resource to attach rating | 
 **resourceId** | **String**| ID of resource to attach rating | 
 **userId** | **String**| ID of user to filter by | 
 **data** | **Object**| Provide your rating data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

