# WorkEvolveApi.ReplyOfReplyApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllRepliesOfReply**](ReplyOfReplyApi.md#getAllRepliesOfReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/get | Get all replies of reply resource
[**getReplyOfReplyById**](ReplyOfReplyApi.md#getReplyOfReplyById) | **GET** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/{replyLevel2Id} | Get a reply of reply resource by id
[**saveReplyOfReply**](ReplyOfReplyApi.md#saveReplyOfReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies | Save a new reply of reply resource
[**updateReplyOfReply**](ReplyOfReplyApi.md#updateReplyOfReply) | **POST** /tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/{replyLevel2Id} | Update reply of reply resource by id


<a name="getAllRepliesOfReply"></a>
# **getAllRepliesOfReply**
> getAllRepliesOfReply(tenantId, resource, resourceId, postId, replyId, opts)

Get all replies of reply resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ReplyOfReplyApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var resource = "resource_example"; // String | Name of resource to attach post

var resourceId = "resourceId_example"; // String | ID of resource to attach post

var postId = "postId_example"; // String | ID of post to filter by

var replyId = "replyId_example"; // String | ID of reply to filter by

var opts = { 
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllRepliesOfReply(tenantId, resource, resourceId, postId, replyId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **resource** | **String**| Name of resource to attach post | 
 **resourceId** | **String**| ID of resource to attach post | 
 **postId** | **String**| ID of post to filter by | 
 **replyId** | **String**| ID of reply to filter by | 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReplyOfReplyById"></a>
# **getReplyOfReplyById**
> getReplyOfReplyById(tenantId, resource, resourceId, postId, replyId, replyLevel2Id)

Get a reply of reply resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ReplyOfReplyApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var resource = "resource_example"; // String | Name of resource to attach post

var resourceId = "resourceId_example"; // String | ID of resource to attach post

var postId = "postId_example"; // String | ID of post to filter by

var replyId = "replyId_example"; // String | ID of reply to filter by

var replyLevel2Id = "replyLevel2Id_example"; // String | ID of reply of reply to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getReplyOfReplyById(tenantId, resource, resourceId, postId, replyId, replyLevel2Id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **resource** | **String**| Name of resource to attach post | 
 **resourceId** | **String**| ID of resource to attach post | 
 **postId** | **String**| ID of post to filter by | 
 **replyId** | **String**| ID of reply to filter by | 
 **replyLevel2Id** | **String**| ID of reply of reply to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveReplyOfReply"></a>
# **saveReplyOfReply**
> saveReplyOfReply(tenantId, resource, resourceId, postId, replyId, data)

Save a new reply of reply resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ReplyOfReplyApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var resource = "resource_example"; // String | Name of resource to attach post

var resourceId = "resourceId_example"; // String | ID of resource to attach post

var postId = "postId_example"; // String | ID of post to filter by

var replyId = "replyId_example"; // String | ID of reply to filter by

var data = null; // Object | Provide your reply of reply data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveReplyOfReply(tenantId, resource, resourceId, postId, replyId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **resource** | **String**| Name of resource to attach post | 
 **resourceId** | **String**| ID of resource to attach post | 
 **postId** | **String**| ID of post to filter by | 
 **replyId** | **String**| ID of reply to filter by | 
 **data** | **Object**| Provide your reply of reply data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateReplyOfReply"></a>
# **updateReplyOfReply**
> updateReplyOfReply(tenantId, resource, resourceId, postId, replyId, replyLevel2Id, data)

Update reply of reply resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.ReplyOfReplyApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var resource = "resource_example"; // String | Name of resource to attach post

var resourceId = "resourceId_example"; // String | ID of resource to attach post

var postId = "postId_example"; // String | ID of post to filter by

var replyId = "replyId_example"; // String | ID of reply to filter by

var replyLevel2Id = "replyLevel2Id_example"; // String | ID reply of reply to filter by

var data = null; // Object | Provide your reply of reply data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateReplyOfReply(tenantId, resource, resourceId, postId, replyId, replyLevel2Id, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **resource** | **String**| Name of resource to attach post | 
 **resourceId** | **String**| ID of resource to attach post | 
 **postId** | **String**| ID of post to filter by | 
 **replyId** | **String**| ID of reply to filter by | 
 **replyLevel2Id** | **String**| ID reply of reply to filter by | 
 **data** | **Object**| Provide your reply of reply data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

