# WorkEvolveApi.UdcTypeApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllUdcTypes**](UdcTypeApi.md#getAllUdcTypes) | **POST** /systems/{sysCode}/types/get | Get all udc types resource without tenant
[**getAllUdcTypesTenant**](UdcTypeApi.md#getAllUdcTypesTenant) | **POST** /tenants/{tenantId}/systems/{sysCode}/types/get | Get all udc types resource with tenant
[**getUdcTypeById**](UdcTypeApi.md#getUdcTypeById) | **GET** /systems/{sysCode}/types/{typeId} | Get a udc type without tenant resource by id
[**getUdcTypeTenantById**](UdcTypeApi.md#getUdcTypeTenantById) | **GET** /tenants/{tenantId}/systems/{sysCode}/types/{typeId} | Get a udc type with tenant resource by id
[**removeUdcTypeById**](UdcTypeApi.md#removeUdcTypeById) | **DELETE** /systems/{sysCode}/types/{typeId} | Delete udc type resource without tenant by id
[**removeUdcTypeTenantById**](UdcTypeApi.md#removeUdcTypeTenantById) | **DELETE** /tenants/{tenantId}/systems/{sysCode}/types/{typeId} | Delete udc type resource with tenant by id
[**saveUdcType**](UdcTypeApi.md#saveUdcType) | **POST** /systems/{sysCode}/types | Save a new udc type resource without tenant
[**saveUdcTypeTenant**](UdcTypeApi.md#saveUdcTypeTenant) | **POST** /tenants/{tenantId}/systems/{sysCode}/types | Save a new udc type resource with tenant
[**updateUdcTenantType**](UdcTypeApi.md#updateUdcTenantType) | **POST** /tenants/{tenantId}/systems/{sysCode}/types/{typeId} | Update udc type resource with tenant by id
[**updateUdcType**](UdcTypeApi.md#updateUdcType) | **POST** /systems/{sysCode}/types/{typeId} | Update udc type resource with tenantout by id


<a name="getAllUdcTypes"></a>
# **getAllUdcTypes**
> getAllUdcTypes(sysCode, opts)

Get all udc types resource without tenant

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var sysCode = "sysCode_example"; // String | Code of system to filter by

var opts = { 
  'filter': null, // Object | Filter udc type by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllUdcTypes(sysCode, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sysCode** | **String**| Code of system to filter by | 
 **filter** | **Object**| Filter udc type by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getAllUdcTypesTenant"></a>
# **getAllUdcTypesTenant**
> getAllUdcTypesTenant(tenantId, sysCode, opts)

Get all udc types resource with tenant

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var sysCode = "sysCode_example"; // String | Code of system to filter by

var opts = { 
  'filter': null, // Object | Filter udc type by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllUdcTypesTenant(tenantId, sysCode, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **sysCode** | **String**| Code of system to filter by | 
 **filter** | **Object**| Filter udc type by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getUdcTypeById"></a>
# **getUdcTypeById**
> getUdcTypeById(sysCode, typeId)

Get a udc type without tenant resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var sysCode = "sysCode_example"; // String | Code of system to filter by

var typeId = "typeId_example"; // String | ID of udc type to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getUdcTypeById(sysCode, typeId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sysCode** | **String**| Code of system to filter by | 
 **typeId** | **String**| ID of udc type to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getUdcTypeTenantById"></a>
# **getUdcTypeTenantById**
> getUdcTypeTenantById(tenantId, sysCode, typeId)

Get a udc type with tenant resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var sysCode = "sysCode_example"; // String | Code of system to filter by

var typeId = "typeId_example"; // String | ID of udc type to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getUdcTypeTenantById(tenantId, sysCode, typeId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **sysCode** | **String**| Code of system to filter by | 
 **typeId** | **String**| ID of udc type to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeUdcTypeById"></a>
# **removeUdcTypeById**
> removeUdcTypeById(sysCode, typeId)

Delete udc type resource without tenant by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var sysCode = "sysCode_example"; // String | Code of system to filter by

var typeId = "typeId_example"; // String | ID of udc type to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeUdcTypeById(sysCode, typeId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sysCode** | **String**| Code of system to filter by | 
 **typeId** | **String**| ID of udc type to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeUdcTypeTenantById"></a>
# **removeUdcTypeTenantById**
> removeUdcTypeTenantById(tenantId, sysCode, typeId)

Delete udc type resource with tenant by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var sysCode = "sysCode_example"; // String | Code of system to filter by

var typeId = "typeId_example"; // String | ID of udc type to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeUdcTypeTenantById(tenantId, sysCode, typeId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **sysCode** | **String**| Code of system to filter by | 
 **typeId** | **String**| ID of udc type to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveUdcType"></a>
# **saveUdcType**
> saveUdcType(sysCode, data)

Save a new udc type resource without tenant

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var sysCode = "sysCode_example"; // String | Code of system to filter by

var data = null; // Object | Provide your udc type data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveUdcType(sysCode, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sysCode** | **String**| Code of system to filter by | 
 **data** | **Object**| Provide your udc type data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveUdcTypeTenant"></a>
# **saveUdcTypeTenant**
> saveUdcTypeTenant(tenantId, sysCode, data)

Save a new udc type resource with tenant

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var sysCode = "sysCode_example"; // String | Code of system to filter by

var data = null; // Object | Provide your udc type data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveUdcTypeTenant(tenantId, sysCode, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **sysCode** | **String**| Code of system to filter by | 
 **data** | **Object**| Provide your udc type data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateUdcTenantType"></a>
# **updateUdcTenantType**
> updateUdcTenantType(tenantId, sysCode, typeId, data)

Update udc type resource with tenant by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var sysCode = "sysCode_example"; // String | Code of system to filter by

var typeId = "typeId_example"; // String | ID of udc type to filter by

var data = null; // Object | Provide your udc type data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateUdcTenantType(tenantId, sysCode, typeId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **sysCode** | **String**| Code of system to filter by | 
 **typeId** | **String**| ID of udc type to filter by | 
 **data** | **Object**| Provide your udc type data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateUdcType"></a>
# **updateUdcType**
> updateUdcType(sysCode, typeId, data)

Update udc type resource with tenantout by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UdcTypeApi();

var sysCode = "sysCode_example"; // String | Code of system to filter by

var typeId = "typeId_example"; // String | ID of udc type to filter by

var data = null; // Object | Provide your udc type data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateUdcType(sysCode, typeId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sysCode** | **String**| Code of system to filter by | 
 **typeId** | **String**| ID of udc type to filter by | 
 **data** | **Object**| Provide your udc type data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

