# WorkEvolveApi.UploadApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**removeUploadFile**](UploadApi.md#removeUploadFile) | **DELETE** /tenants/{tenantId}/upload/{fileId} | Remove an uploaded file resource
[**uploadFile**](UploadApi.md#uploadFile) | **POST** /tenants/{tenantId}/upload | Upload a new file resource


<a name="removeUploadFile"></a>
# **removeUploadFile**
> removeUploadFile(tenantId, fileId)

Remove an uploaded file resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UploadApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var fileId = "fileId_example"; // String | ID of file to remove


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeUploadFile(tenantId, fileId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **fileId** | **String**| ID of file to remove | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="uploadFile"></a>
# **uploadFile**
> uploadFile(tenantId, file)

Upload a new file resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UploadApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var file = "/path/to/file.txt"; // File | Provide your new file data information to upload


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.uploadFile(tenantId, file, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **file** | **File**| Provide your new file data information to upload | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

