# WorkEvolveApi.UserSecurityApi

All URIs are relative to *http://localhost/websiteapi/sourcecode/public/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllUserSecurities**](UserSecurityApi.md#getAllUserSecurities) | **POST** /tenants/{tenantId}/usersecurity/get | Get all user securities resource
[**getUserSecurityById**](UserSecurityApi.md#getUserSecurityById) | **GET** /tenants/{tenantId}/usersecurity/{userSecurityId} | Get a user security resource by id
[**removeUserSecurityById**](UserSecurityApi.md#removeUserSecurityById) | **DELETE** /tenants/{tenantId}/usersecurity/{userSecurityId} | Delete user security resource by id
[**saveUserSecurity**](UserSecurityApi.md#saveUserSecurity) | **POST** /tenants/{tenantId}/usersecurity | Save a new user security resource
[**updateUserSecurity**](UserSecurityApi.md#updateUserSecurity) | **POST** /tenants/{tenantId}/usersecurity/{userSecurityId} | Update user security resource by id


<a name="getAllUserSecurities"></a>
# **getAllUserSecurities**
> getAllUserSecurities(tenantId, opts)

Get all user securities resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UserSecurityApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var opts = { 
  'filter': null, // Object | Filter user security by condition provided
  'offset': 0, // Number | The number of items to skip before starting to collect the result set
  'limit': 25 // Number | The number of items to return
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getAllUserSecurities(tenantId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **filter** | **Object**| Filter user security by condition provided | [optional] 
 **offset** | **Number**| The number of items to skip before starting to collect the result set | [optional] [default to 0]
 **limit** | **Number**| The number of items to return | [optional] [default to 25]

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getUserSecurityById"></a>
# **getUserSecurityById**
> getUserSecurityById(tenantId, userSecurityId)

Get a user security resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UserSecurityApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var userSecurityId = "userSecurityId_example"; // String | ID of user security to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.getUserSecurityById(tenantId, userSecurityId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **userSecurityId** | **String**| ID of user security to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeUserSecurityById"></a>
# **removeUserSecurityById**
> removeUserSecurityById(tenantId, userSecurityId)

Delete user security resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UserSecurityApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var userSecurityId = "userSecurityId_example"; // String | ID of user security to filter by


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.removeUserSecurityById(tenantId, userSecurityId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **userSecurityId** | **String**| ID of user security to filter by | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="saveUserSecurity"></a>
# **saveUserSecurity**
> saveUserSecurity(tenantId, data)

Save a new user security resource

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UserSecurityApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var data = null; // Object | Provide your user security data information to save


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.saveUserSecurity(tenantId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **data** | **Object**| Provide your user security data information to save | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateUserSecurity"></a>
# **updateUserSecurity**
> updateUserSecurity(tenantId, userSecurityId, data)

Update user security resource by id

### Example
```javascript
var WorkEvolveApi = require('work_evolve_api');
var defaultClient = WorkEvolveApi.ApiClient.instance;

// Configure API key authorization: default
var default = defaultClient.authentications['default'];
default.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//default.apiKeyPrefix = 'Token';

var apiInstance = new WorkEvolveApi.UserSecurityApi();

var tenantId = "tenantId_example"; // String | ID of tenant to filter by

var userSecurityId = "userSecurityId_example"; // String | ID of user security to filter by

var data = null; // Object | Provide your user security data information to update


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateUserSecurity(tenantId, userSecurityId, data, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| ID of tenant to filter by | 
 **userSecurityId** | **String**| ID of user security to filter by | 
 **data** | **Object**| Provide your user security data information to update | 

### Return type

null (empty response body)

### Authorization

[default](../README.md#default)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

