/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.ApplicationPermissionApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * ApplicationPermission service.
   * @module api/ApplicationPermissionApi
   * @version 0.1.0
   */

  /**
   * Constructs a new ApplicationPermissionApi. 
   * @alias module:api/ApplicationPermissionApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllApplicationPermissions operation.
     * @callback module:api/ApplicationPermissionApi~getAllApplicationPermissionsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all application permissions resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter application permissions by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/ApplicationPermissionApi~getAllApplicationPermissionsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllApplicationPermissions = function(tenantId, role, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllApplicationPermissions");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling getAllApplicationPermissions");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/applicationpermission/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getApplicationPermissionById operation.
     * @callback module:api/ApplicationPermissionApi~getApplicationPermissionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get an application permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId Id of application permission to filter by
     * @param {module:api/ApplicationPermissionApi~getApplicationPermissionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getApplicationPermissionById = function(tenantId, role, permissionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getApplicationPermissionById");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling getApplicationPermissionById");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling getApplicationPermissionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeApplicationPermissionById operation.
     * @callback module:api/ApplicationPermissionApi~removeApplicationPermissionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete application permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId ID of application permission to filter by
     * @param {module:api/ApplicationPermissionApi~removeApplicationPermissionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeApplicationPermissionById = function(tenantId, role, permissionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeApplicationPermissionById");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling removeApplicationPermissionById");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling removeApplicationPermissionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveApplicationPermission operation.
     * @callback module:api/ApplicationPermissionApi~saveApplicationPermissionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new application permission resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {Object} data Provide your application permission data information to save
     * @param {module:api/ApplicationPermissionApi~saveApplicationPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveApplicationPermission = function(tenantId, role, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveApplicationPermission");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling saveApplicationPermission");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveApplicationPermission");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/applicationpermission', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateApplicationPermission operation.
     * @callback module:api/ApplicationPermissionApi~updateApplicationPermissionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update application permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId ID of application permission to filter by
     * @param {Object} data Provide your application permission data information to update
     * @param {module:api/ApplicationPermissionApi~updateApplicationPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateApplicationPermission = function(tenantId, role, permissionId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateApplicationPermission");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling updateApplicationPermission");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling updateApplicationPermission");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateApplicationPermission");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/applicationpermission/{permissionId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
