/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.ColumnPermissionApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * ColumnPermission service.
   * @module api/ColumnPermissionApi
   * @version 0.1.0
   */

  /**
   * Constructs a new ColumnPermissionApi. 
   * @alias module:api/ColumnPermissionApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllColumnPermissions operation.
     * @callback module:api/ColumnPermissionApi~getAllColumnPermissionsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all column permissions resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter column permissions by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/ColumnPermissionApi~getAllColumnPermissionsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllColumnPermissions = function(tenantId, role, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllColumnPermissions");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling getAllColumnPermissions");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/columnpermission/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getColumnPermissionById operation.
     * @callback module:api/ColumnPermissionApi~getColumnPermissionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a column permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId Id of column permission to filter by
     * @param {module:api/ColumnPermissionApi~getColumnPermissionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getColumnPermissionById = function(tenantId, role, permissionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getColumnPermissionById");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling getColumnPermissionById");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling getColumnPermissionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/columnpermission/{permissionId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeColumnPermissionById operation.
     * @callback module:api/ColumnPermissionApi~removeColumnPermissionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete column permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId ID of column permission to filter by
     * @param {module:api/ColumnPermissionApi~removeColumnPermissionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeColumnPermissionById = function(tenantId, role, permissionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeColumnPermissionById");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling removeColumnPermissionById");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling removeColumnPermissionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/columnpermission/{permissionId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveColumnPermission operation.
     * @callback module:api/ColumnPermissionApi~saveColumnPermissionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new column permission resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {Object} data Provide your column permission data information to save
     * @param {module:api/ColumnPermissionApi~saveColumnPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveColumnPermission = function(tenantId, role, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveColumnPermission");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling saveColumnPermission");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveColumnPermission");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/columnpermission', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateColumnPermission operation.
     * @callback module:api/ColumnPermissionApi~updateColumnPermissionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update column permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId ID of column permission to filter by
     * @param {Object} data Provide your column permission data information to update
     * @param {module:api/ColumnPermissionApi~updateColumnPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateColumnPermission = function(tenantId, role, permissionId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateColumnPermission");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling updateColumnPermission");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling updateColumnPermission");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateColumnPermission");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/columnpermission/{permissionId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
