/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.DataRevisionApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * DataRevision service.
   * @module api/DataRevisionApi
   * @version 0.1.0
   */

  /**
   * Constructs a new DataRevisionApi. 
   * @alias module:api/DataRevisionApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllEvents operation.
     * @callback module:api/DataRevisionApi~getAllEventsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all events
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} opts Optional parameters
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/DataRevisionApi~getAllEventsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllEvents = function(tenantId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllEvents");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/events', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDataByEvent operation.
     * @callback module:api/DataRevisionApi~getDataByEventCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get data by specific event
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} event Event to filter by
     * @param {module:api/DataRevisionApi~getDataByEventCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getDataByEvent = function(tenantId, event, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getDataByEvent");
      }

      // verify the required parameter 'event' is set
      if (event === undefined || event === null) {
        throw new Error("Missing the required parameter 'event' when calling getDataByEvent");
      }


      var pathParams = {
        'tenantId': tenantId,
        'event': event
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/events/{event}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDataByRevision operation.
     * @callback module:api/DataRevisionApi~getDataByRevisionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get data of an item by specific revision
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach revision
     * @param {String} resourceId ID of resource to attach revision
     * @param {String} revision Revision to filter by
     * @param {Object} opts Optional parameters
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/DataRevisionApi~getDataByRevisionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getDataByRevision = function(tenantId, resource, resourceId, revision, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getDataByRevision");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getDataByRevision");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getDataByRevision");
      }

      // verify the required parameter 'revision' is set
      if (revision === undefined || revision === null) {
        throw new Error("Missing the required parameter 'revision' when calling getDataByRevision");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'revision': revision
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/revisions/{revision}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDataFromAllRevisions operation.
     * @callback module:api/DataRevisionApi~getDataFromAllRevisionsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get data of an item from all revisions
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach revision
     * @param {String} resourceId ID of resource to attach revision
     * @param {Object} opts Optional parameters
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/DataRevisionApi~getDataFromAllRevisionsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getDataFromAllRevisions = function(tenantId, resource, resourceId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getDataFromAllRevisions");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getDataFromAllRevisions");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getDataFromAllRevisions");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/revisions', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDataRevisionGroupByVersionNo operation.
     * @callback module:api/DataRevisionApi~getDataRevisionGroupByVersionNoCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get data of an item from all revisions that group by revision No
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach revision
     * @param {String} resourceId ID of resource to attach revision
     * @param {Object} opts Optional parameters
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/DataRevisionApi~getDataRevisionGroupByVersionNoCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getDataRevisionGroupByVersionNo = function(tenantId, resource, resourceId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getDataRevisionGroupByVersionNo");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getDataRevisionGroupByVersionNo");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getDataRevisionGroupByVersionNo");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/revisions/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDifferencesByRevision operation.
     * @callback module:api/DataRevisionApi~getDifferencesByRevisionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get the difference in fields values between the two revisions
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach revision
     * @param {String} resourceId ID of resource to attach revision
     * @param {String} revisionFrom Revision from to filter by
     * @param {String} revisionTo Revision to to filter by
     * @param {Object} opts Optional parameters
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/DataRevisionApi~getDifferencesByRevisionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getDifferencesByRevision = function(tenantId, resource, resourceId, revisionFrom, revisionTo, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getDifferencesByRevision");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getDifferencesByRevision");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getDifferencesByRevision");
      }

      // verify the required parameter 'revisionFrom' is set
      if (revisionFrom === undefined || revisionFrom === null) {
        throw new Error("Missing the required parameter 'revisionFrom' when calling getDifferencesByRevision");
      }

      // verify the required parameter 'revisionTo' is set
      if (revisionTo === undefined || revisionTo === null) {
        throw new Error("Missing the required parameter 'revisionTo' when calling getDifferencesByRevision");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'revisionFrom': revisionFrom,
        'revisionTo': revisionTo
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/revisions/{revisionFrom}/{revisionTo}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the revertDataByEvent operation.
     * @callback module:api/DataRevisionApi~revertDataByEventCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Reverts the item to the values in the given event. This will undo any changes made after the given event.
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} event Event to filter by
     * @param {module:api/DataRevisionApi~revertDataByEventCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.revertDataByEvent = function(tenantId, event, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling revertDataByEvent");
      }

      // verify the required parameter 'event' is set
      if (event === undefined || event === null) {
        throw new Error("Missing the required parameter 'event' when calling revertDataByEvent");
      }


      var pathParams = {
        'tenantId': tenantId,
        'event': event
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/events/{event}/revert', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the revertDataByRevision operation.
     * @callback module:api/DataRevisionApi~revertDataByRevisionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Reverts the item to the values in the given revision. This will undo any changes made after the given revision.
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach revision
     * @param {String} resourceId ID of resource to attach revision
     * @param {String} revision Revision to filter by
     * @param {module:api/DataRevisionApi~revertDataByRevisionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.revertDataByRevision = function(tenantId, resource, resourceId, revision, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling revertDataByRevision");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling revertDataByRevision");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling revertDataByRevision");
      }

      // verify the required parameter 'revision' is set
      if (revision === undefined || revision === null) {
        throw new Error("Missing the required parameter 'revision' when calling revertDataByRevision");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'revision': revision
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/revisions/{revision}/revert', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
