/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.FormApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * Form service.
   * @module api/FormApi
   * @version 0.1.0
   */

  /**
   * Constructs a new FormApi. 
   * @alias module:api/FormApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllForms operation.
     * @callback module:api/FormApi~getAllFormsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all forms resource
     * @param {String} proId ID of program to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter forms by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/FormApi~getAllFormsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllForms = function(proId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling getAllForms");
      }


      var pathParams = {
        'proId': proId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}/forms/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getFormById operation.
     * @callback module:api/FormApi~getFormByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a form resource by id
     * @param {String} proId ID of program to filter by
     * @param {String} formId ID of form to filter by
     * @param {module:api/FormApi~getFormByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getFormById = function(proId, formId, callback) {
      var postBody = null;

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling getFormById");
      }

      // verify the required parameter 'formId' is set
      if (formId === undefined || formId === null) {
        throw new Error("Missing the required parameter 'formId' when calling getFormById");
      }


      var pathParams = {
        'proId': proId,
        'formId': formId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}/forms/{formId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeFormById operation.
     * @callback module:api/FormApi~removeFormByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete form resource by id
     * @param {String} proId ID of program to filter by
     * @param {String} formId ID of form to filter by
     * @param {module:api/FormApi~removeFormByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeFormById = function(proId, formId, callback) {
      var postBody = null;

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling removeFormById");
      }

      // verify the required parameter 'formId' is set
      if (formId === undefined || formId === null) {
        throw new Error("Missing the required parameter 'formId' when calling removeFormById");
      }


      var pathParams = {
        'proId': proId,
        'formId': formId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}/forms/{formId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveForm operation.
     * @callback module:api/FormApi~saveFormCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new form resource
     * @param {String} proId ID of program to filter by
     * @param {Object} data Provide your form data information to save
     * @param {module:api/FormApi~saveFormCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveForm = function(proId, data, callback) {
      var postBody = data;

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling saveForm");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveForm");
      }


      var pathParams = {
        'proId': proId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}/forms', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateForm operation.
     * @callback module:api/FormApi~updateFormCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update form resource by id
     * @param {String} proId ID of program to filter by
     * @param {String} formId ID of form to filter by
     * @param {Object} data Provide your form data information to update
     * @param {module:api/FormApi~updateFormCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateForm = function(proId, formId, data, callback) {
      var postBody = data;

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling updateForm");
      }

      // verify the required parameter 'formId' is set
      if (formId === undefined || formId === null) {
        throw new Error("Missing the required parameter 'formId' when calling updateForm");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateForm");
      }


      var pathParams = {
        'proId': proId,
        'formId': formId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}/forms/{formId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
