/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.LookupApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * Lookup service.
   * @module api/LookupApi
   * @version 0.1.0
   */

  /**
   * Constructs a new LookupApi. 
   * @alias module:api/LookupApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getLookups operation.
     * @callback module:api/LookupApi~getLookupsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get datasources resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} data Provide your lookup data information to read datasource
     * @param {module:api/LookupApi~getLookupsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getLookups = function(tenantId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getLookups");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling getLookups");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/lookup', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
