/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.MenuSelectionApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * MenuSelection service.
   * @module api/MenuSelectionApi
   * @version 0.1.0
   */

  /**
   * Constructs a new MenuSelectionApi. 
   * @alias module:api/MenuSelectionApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllMenuSelections operation.
     * @callback module:api/MenuSelectionApi~getAllMenuSelectionsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all menu selections resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} menuId ID of menu to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter menu selections by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/MenuSelectionApi~getAllMenuSelectionsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllMenuSelections = function(tenantId, menuId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllMenuSelections");
      }

      // verify the required parameter 'menuId' is set
      if (menuId === undefined || menuId === null) {
        throw new Error("Missing the required parameter 'menuId' when calling getAllMenuSelections");
      }


      var pathParams = {
        'tenantId': tenantId,
        'menuId': menuId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/menus/{menuId}/menuselections/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeMenuSelectionById operation.
     * @callback module:api/MenuSelectionApi~removeMenuSelectionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete menu selection resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} menuId ID of menu to filter by
     * @param {String} selectionId ID of selection to filter by
     * @param {module:api/MenuSelectionApi~removeMenuSelectionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeMenuSelectionById = function(tenantId, menuId, selectionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeMenuSelectionById");
      }

      // verify the required parameter 'menuId' is set
      if (menuId === undefined || menuId === null) {
        throw new Error("Missing the required parameter 'menuId' when calling removeMenuSelectionById");
      }

      // verify the required parameter 'selectionId' is set
      if (selectionId === undefined || selectionId === null) {
        throw new Error("Missing the required parameter 'selectionId' when calling removeMenuSelectionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'menuId': menuId,
        'selectionId': selectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/menus/{menuId}/menuselections/{selectionId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveMenuSelection operation.
     * @callback module:api/MenuSelectionApi~saveMenuSelectionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new menu selection resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} menuId ID of menu to filter by
     * @param {Object} data Provide your menu selection data information to save
     * @param {module:api/MenuSelectionApi~saveMenuSelectionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveMenuSelection = function(tenantId, menuId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveMenuSelection");
      }

      // verify the required parameter 'menuId' is set
      if (menuId === undefined || menuId === null) {
        throw new Error("Missing the required parameter 'menuId' when calling saveMenuSelection");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveMenuSelection");
      }


      var pathParams = {
        'tenantId': tenantId,
        'menuId': menuId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/menus/{menuId}/menuselections', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateBatchMenuSelection operation.
     * @callback module:api/MenuSelectionApi~updateBatchMenuSelectionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * update batch of MenuSelection
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} menuId ID of menu master to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.data Provide your role MenuSelection information to save
     * @param {module:api/MenuSelectionApi~updateBatchMenuSelectionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateBatchMenuSelection = function(tenantId, menuId, opts, callback) {
      opts = opts || {};
      var postBody = opts['data'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateBatchMenuSelection");
      }

      // verify the required parameter 'menuId' is set
      if (menuId === undefined || menuId === null) {
        throw new Error("Missing the required parameter 'menuId' when calling updateBatchMenuSelection");
      }


      var pathParams = {
        'tenantId': tenantId,
        'menuId': menuId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/menus/{menuId}/menuselections/batch', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateMenuSelection operation.
     * @callback module:api/MenuSelectionApi~updateMenuSelectionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update menu selection resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} menuId ID of menu to filter by
     * @param {String} selectionId ID of menu selection to filter by
     * @param {Object} data Provide your menu selection data information to update
     * @param {module:api/MenuSelectionApi~updateMenuSelectionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateMenuSelection = function(tenantId, menuId, selectionId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateMenuSelection");
      }

      // verify the required parameter 'menuId' is set
      if (menuId === undefined || menuId === null) {
        throw new Error("Missing the required parameter 'menuId' when calling updateMenuSelection");
      }

      // verify the required parameter 'selectionId' is set
      if (selectionId === undefined || selectionId === null) {
        throw new Error("Missing the required parameter 'selectionId' when calling updateMenuSelection");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateMenuSelection");
      }


      var pathParams = {
        'tenantId': tenantId,
        'menuId': menuId,
        'selectionId': selectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/menus/{menuId}/menuselections/{selectionId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
