/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.ObjectLibraryApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * ObjectLibrary service.
   * @module api/ObjectLibraryApi
   * @version 0.1.0
   */

  /**
   * Constructs a new ObjectLibraryApi. 
   * @alias module:api/ObjectLibraryApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllObjectLibraries operation.
     * @callback module:api/ObjectLibraryApi~getAllObjectLibrariesCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all object libraries resource
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter object libraries by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/ObjectLibraryApi~getAllObjectLibrariesCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllObjectLibraries = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];


      var pathParams = {
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/objectlibraries/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getObjectLibraryById operation.
     * @callback module:api/ObjectLibraryApi~getObjectLibraryByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get an object library resource by id
     * @param {String} objId ID of object library to filter by
     * @param {module:api/ObjectLibraryApi~getObjectLibraryByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getObjectLibraryById = function(objId, callback) {
      var postBody = null;

      // verify the required parameter 'objId' is set
      if (objId === undefined || objId === null) {
        throw new Error("Missing the required parameter 'objId' when calling getObjectLibraryById");
      }


      var pathParams = {
        'objId': objId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/objectlibraries/{objId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeObjectLibraryById operation.
     * @callback module:api/ObjectLibraryApi~removeObjectLibraryByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete object library resource by id
     * @param {String} objId ID of object library to filter by
     * @param {module:api/ObjectLibraryApi~removeObjectLibraryByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeObjectLibraryById = function(objId, callback) {
      var postBody = null;

      // verify the required parameter 'objId' is set
      if (objId === undefined || objId === null) {
        throw new Error("Missing the required parameter 'objId' when calling removeObjectLibraryById");
      }


      var pathParams = {
        'objId': objId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/objectlibraries/{objId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveObjectLibrary operation.
     * @callback module:api/ObjectLibraryApi~saveObjectLibraryCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new object library resource
     * @param {Object} data Provide your object library data information to save
     * @param {module:api/ObjectLibraryApi~saveObjectLibraryCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveObjectLibrary = function(data, callback) {
      var postBody = data;

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveObjectLibrary");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/objectlibraries', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateBatchObjectLibrary operation.
     * @callback module:api/ObjectLibraryApi~updateBatchObjectLibraryCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * update batch of ObjectLibrary
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.data Provide your ObjectLibrary data information to save
     * @param {module:api/ObjectLibraryApi~updateBatchObjectLibraryCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateBatchObjectLibrary = function(tenantId, opts, callback) {
      opts = opts || {};
      var postBody = opts['data'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateBatchObjectLibrary");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/objectlibraries/batch', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateObjectLibrary operation.
     * @callback module:api/ObjectLibraryApi~updateObjectLibraryCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update object library resource by id
     * @param {String} objId ID of object library to filter by
     * @param {Object} data Provide your object library data information to update
     * @param {module:api/ObjectLibraryApi~updateObjectLibraryCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateObjectLibrary = function(objId, data, callback) {
      var postBody = data;

      // verify the required parameter 'objId' is set
      if (objId === undefined || objId === null) {
        throw new Error("Missing the required parameter 'objId' when calling updateObjectLibrary");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateObjectLibrary");
      }


      var pathParams = {
        'objId': objId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/objectlibraries/{objId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
