/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.ProgramApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * Program service.
   * @module api/ProgramApi
   * @version 0.1.0
   */

  /**
   * Constructs a new ProgramApi. 
   * @alias module:api/ProgramApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllPrograms operation.
     * @callback module:api/ProgramApi~getAllProgramsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all programs resource
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter programs by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/ProgramApi~getAllProgramsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllPrograms = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];


      var pathParams = {
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProgramById operation.
     * @callback module:api/ProgramApi~getProgramByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a program resource by id
     * @param {String} proId ID of program to filter by
     * @param {module:api/ProgramApi~getProgramByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getProgramById = function(proId, callback) {
      var postBody = null;

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling getProgramById");
      }


      var pathParams = {
        'proId': proId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeProgramById operation.
     * @callback module:api/ProgramApi~removeProgramByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete program resource by id
     * @param {String} proId ID of program to filter by
     * @param {module:api/ProgramApi~removeProgramByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeProgramById = function(proId, callback) {
      var postBody = null;

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling removeProgramById");
      }


      var pathParams = {
        'proId': proId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveProgram operation.
     * @callback module:api/ProgramApi~saveProgramCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new program resource
     * @param {Object} data Provide your program data information to save
     * @param {module:api/ProgramApi~saveProgramCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveProgram = function(data, callback) {
      var postBody = data;

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveProgram");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProgram operation.
     * @callback module:api/ProgramApi~updateProgramCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update program resource by id
     * @param {String} proId ID of program to filter by
     * @param {Object} data Provide your program data information to update
     * @param {module:api/ProgramApi~updateProgramCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateProgram = function(proId, data, callback) {
      var postBody = data;

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling updateProgram");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateProgram");
      }


      var pathParams = {
        'proId': proId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/programs/{proId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
