/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.ReactionApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * Reaction service.
   * @module api/ReactionApi
   * @version 0.1.0
   */

  /**
   * Constructs a new ReactionApi. 
   * @alias module:api/ReactionApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllReactions operation.
     * @callback module:api/ReactionApi~getAllReactionsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all reactions resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach reaction
     * @param {String} resourceId ID of resource to attach reaction
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter reactions by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/ReactionApi~getAllReactionsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllReactions = function(tenantId, resource, resourceId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllReactions");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getAllReactions");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getAllReactions");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/reactions/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getReactionById operation.
     * @callback module:api/ReactionApi~getReactionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a reaction resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach reaction
     * @param {String} resourceId ID of resource to attach reaction
     * @param {String} reactionId ID of reaction to filter by
     * @param {module:api/ReactionApi~getReactionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getReactionById = function(tenantId, resource, resourceId, reactionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getReactionById");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getReactionById");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getReactionById");
      }

      // verify the required parameter 'reactionId' is set
      if (reactionId === undefined || reactionId === null) {
        throw new Error("Missing the required parameter 'reactionId' when calling getReactionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'reactionId': reactionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/reactions/{reactionId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeReactoinById operation.
     * @callback module:api/ReactionApi~removeReactoinByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete reaction resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach reaction
     * @param {String} resourceId ID of resource to attach reaction
     * @param {String} reactionId ID of reaction to filter by
     * @param {module:api/ReactionApi~removeReactoinByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeReactoinById = function(tenantId, resource, resourceId, reactionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeReactoinById");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling removeReactoinById");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling removeReactoinById");
      }

      // verify the required parameter 'reactionId' is set
      if (reactionId === undefined || reactionId === null) {
        throw new Error("Missing the required parameter 'reactionId' when calling removeReactoinById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'reactionId': reactionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/reactions/{reactionId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveReaction operation.
     * @callback module:api/ReactionApi~saveReactionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new reaction resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach reaction
     * @param {String} resourceId ID of resource to attach reaction
     * @param {Object} data Provide your reaction data information to save
     * @param {module:api/ReactionApi~saveReactionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveReaction = function(tenantId, resource, resourceId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveReaction");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling saveReaction");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling saveReaction");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveReaction");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/reactions', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateReaction operation.
     * @callback module:api/ReactionApi~updateReactionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update reaction resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach reaction
     * @param {String} resourceId ID of resource to attach reaction
     * @param {String} reactionId ID of reaction to filter by
     * @param {Object} data Provide your reaction data information to update
     * @param {module:api/ReactionApi~updateReactionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateReaction = function(tenantId, resource, resourceId, reactionId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateReaction");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling updateReaction");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling updateReaction");
      }

      // verify the required parameter 'reactionId' is set
      if (reactionId === undefined || reactionId === null) {
        throw new Error("Missing the required parameter 'reactionId' when calling updateReaction");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateReaction");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'reactionId': reactionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/reactions/{reactionId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
