/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.ReplyOfReplyApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * ReplyOfReply service.
   * @module api/ReplyOfReplyApi
   * @version 0.1.0
   */

  /**
   * Constructs a new ReplyOfReplyApi. 
   * @alias module:api/ReplyOfReplyApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllRepliesOfReply operation.
     * @callback module:api/ReplyOfReplyApi~getAllRepliesOfReplyCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all replies of reply resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach post
     * @param {String} resourceId ID of resource to attach post
     * @param {String} postId ID of post to filter by
     * @param {String} replyId ID of reply to filter by
     * @param {Object} opts Optional parameters
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/ReplyOfReplyApi~getAllRepliesOfReplyCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllRepliesOfReply = function(tenantId, resource, resourceId, postId, replyId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllRepliesOfReply");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getAllRepliesOfReply");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getAllRepliesOfReply");
      }

      // verify the required parameter 'postId' is set
      if (postId === undefined || postId === null) {
        throw new Error("Missing the required parameter 'postId' when calling getAllRepliesOfReply");
      }

      // verify the required parameter 'replyId' is set
      if (replyId === undefined || replyId === null) {
        throw new Error("Missing the required parameter 'replyId' when calling getAllRepliesOfReply");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'postId': postId,
        'replyId': replyId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getReplyOfReplyById operation.
     * @callback module:api/ReplyOfReplyApi~getReplyOfReplyByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a reply of reply resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach post
     * @param {String} resourceId ID of resource to attach post
     * @param {String} postId ID of post to filter by
     * @param {String} replyId ID of reply to filter by
     * @param {String} replyLevel2Id ID of reply of reply to filter by
     * @param {module:api/ReplyOfReplyApi~getReplyOfReplyByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getReplyOfReplyById = function(tenantId, resource, resourceId, postId, replyId, replyLevel2Id, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getReplyOfReplyById");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling getReplyOfReplyById");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling getReplyOfReplyById");
      }

      // verify the required parameter 'postId' is set
      if (postId === undefined || postId === null) {
        throw new Error("Missing the required parameter 'postId' when calling getReplyOfReplyById");
      }

      // verify the required parameter 'replyId' is set
      if (replyId === undefined || replyId === null) {
        throw new Error("Missing the required parameter 'replyId' when calling getReplyOfReplyById");
      }

      // verify the required parameter 'replyLevel2Id' is set
      if (replyLevel2Id === undefined || replyLevel2Id === null) {
        throw new Error("Missing the required parameter 'replyLevel2Id' when calling getReplyOfReplyById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'postId': postId,
        'replyId': replyId,
        'replyLevel2Id': replyLevel2Id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/{replyLevel2Id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveReplyOfReply operation.
     * @callback module:api/ReplyOfReplyApi~saveReplyOfReplyCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new reply of reply resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach post
     * @param {String} resourceId ID of resource to attach post
     * @param {String} postId ID of post to filter by
     * @param {String} replyId ID of reply to filter by
     * @param {Object} data Provide your reply of reply data information to save
     * @param {module:api/ReplyOfReplyApi~saveReplyOfReplyCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveReplyOfReply = function(tenantId, resource, resourceId, postId, replyId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveReplyOfReply");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling saveReplyOfReply");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling saveReplyOfReply");
      }

      // verify the required parameter 'postId' is set
      if (postId === undefined || postId === null) {
        throw new Error("Missing the required parameter 'postId' when calling saveReplyOfReply");
      }

      // verify the required parameter 'replyId' is set
      if (replyId === undefined || replyId === null) {
        throw new Error("Missing the required parameter 'replyId' when calling saveReplyOfReply");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveReplyOfReply");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'postId': postId,
        'replyId': replyId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateReplyOfReply operation.
     * @callback module:api/ReplyOfReplyApi~updateReplyOfReplyCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update reply of reply resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} resource Name of resource to attach post
     * @param {String} resourceId ID of resource to attach post
     * @param {String} postId ID of post to filter by
     * @param {String} replyId ID of reply to filter by
     * @param {String} replyLevel2Id ID reply of reply to filter by
     * @param {Object} data Provide your reply of reply data information to update
     * @param {module:api/ReplyOfReplyApi~updateReplyOfReplyCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateReplyOfReply = function(tenantId, resource, resourceId, postId, replyId, replyLevel2Id, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateReplyOfReply");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling updateReplyOfReply");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling updateReplyOfReply");
      }

      // verify the required parameter 'postId' is set
      if (postId === undefined || postId === null) {
        throw new Error("Missing the required parameter 'postId' when calling updateReplyOfReply");
      }

      // verify the required parameter 'replyId' is set
      if (replyId === undefined || replyId === null) {
        throw new Error("Missing the required parameter 'replyId' when calling updateReplyOfReply");
      }

      // verify the required parameter 'replyLevel2Id' is set
      if (replyLevel2Id === undefined || replyLevel2Id === null) {
        throw new Error("Missing the required parameter 'replyLevel2Id' when calling updateReplyOfReply");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateReplyOfReply");
      }


      var pathParams = {
        'tenantId': tenantId,
        'resource': resource,
        'resourceId': resourceId,
        'postId': postId,
        'replyId': replyId,
        'replyLevel2Id': replyLevel2Id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/{resource}/{resourceId}/posts/{postId}/replies/{replyId}/replies/{replyLevel2Id}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
