/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.RowPermissionApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * RowPermission service.
   * @module api/RowPermissionApi
   * @version 0.1.0
   */

  /**
   * Constructs a new RowPermissionApi. 
   * @alias module:api/RowPermissionApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllRowPermissions operation.
     * @callback module:api/RowPermissionApi~getAllRowPermissionsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all row permissions resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter row permissions by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/RowPermissionApi~getAllRowPermissionsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllRowPermissions = function(tenantId, role, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllRowPermissions");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling getAllRowPermissions");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/rowpermission/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getRowPermissionById operation.
     * @callback module:api/RowPermissionApi~getRowPermissionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a row permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId Id of row permission to filter by
     * @param {module:api/RowPermissionApi~getRowPermissionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getRowPermissionById = function(tenantId, role, permissionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getRowPermissionById");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling getRowPermissionById");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling getRowPermissionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/rowpermission/{permissionId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeRowPermissionById operation.
     * @callback module:api/RowPermissionApi~removeRowPermissionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete row permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId ID of row permission to filter by
     * @param {module:api/RowPermissionApi~removeRowPermissionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeRowPermissionById = function(tenantId, role, permissionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeRowPermissionById");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling removeRowPermissionById");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling removeRowPermissionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/rowpermission/{permissionId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveRowPermission operation.
     * @callback module:api/RowPermissionApi~saveRowPermissionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new row permission resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {Object} data Provide your row permission data information to save
     * @param {module:api/RowPermissionApi~saveRowPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveRowPermission = function(tenantId, role, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveRowPermission");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling saveRowPermission");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveRowPermission");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/rowpermission', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateBatchRowPermission operation.
     * @callback module:api/RowPermissionApi~updateBatchRowPermissionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * update batch of RowPermission
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.data Provide your role data information to save
     * @param {module:api/RowPermissionApi~updateBatchRowPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateBatchRowPermission = function(tenantId, opts, callback) {
      opts = opts || {};
      var postBody = opts['data'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateBatchRowPermission");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/rowpermission/batch', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateRowPermission operation.
     * @callback module:api/RowPermissionApi~updateRowPermissionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update row permission resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} role ID of role to filter by
     * @param {String} permissionId ID of row permission to filter by
     * @param {Object} data Provide your row permission data information to update
     * @param {module:api/RowPermissionApi~updateRowPermissionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateRowPermission = function(tenantId, role, permissionId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateRowPermission");
      }

      // verify the required parameter 'role' is set
      if (role === undefined || role === null) {
        throw new Error("Missing the required parameter 'role' when calling updateRowPermission");
      }

      // verify the required parameter 'permissionId' is set
      if (permissionId === undefined || permissionId === null) {
        throw new Error("Missing the required parameter 'permissionId' when calling updateRowPermission");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateRowPermission");
      }


      var pathParams = {
        'tenantId': tenantId,
        'role': role,
        'permissionId': permissionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/roles/{role}/rowpermission/{permissionId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
