/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.SchemaApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * Schema service.
   * @module api/SchemaApi
   * @version 0.1.0
   */

  /**
   * Constructs a new SchemaApi. 
   * @alias module:api/SchemaApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllSchemas operation.
     * @callback module:api/SchemaApi~getAllSchemasCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all schemas resource
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter schemas by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/SchemaApi~getAllSchemasCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllSchemas = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];


      var pathParams = {
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/schemas/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getDistinctSchema operation.
     * @callback module:api/SchemaApi~getDistinctSchemaCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * get distinct schema records by datasource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} datasource datasource name
     * @param {module:api/SchemaApi~getDistinctSchemaCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getDistinctSchema = function(tenantId, datasource, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getDistinctSchema");
      }

      // verify the required parameter 'datasource' is set
      if (datasource === undefined || datasource === null) {
        throw new Error("Missing the required parameter 'datasource' when calling getDistinctSchema");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
        'datasource': datasource,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/distinct-schema/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSchemaById operation.
     * @callback module:api/SchemaApi~getSchemaByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a schema resource by id
     * @param {String} schemaId ID of schema to filter by
     * @param {module:api/SchemaApi~getSchemaByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getSchemaById = function(schemaId, callback) {
      var postBody = null;

      // verify the required parameter 'schemaId' is set
      if (schemaId === undefined || schemaId === null) {
        throw new Error("Missing the required parameter 'schemaId' when calling getSchemaById");
      }


      var pathParams = {
        'schemaId': schemaId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/schemas/{schemaId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeSchemaById operation.
     * @callback module:api/SchemaApi~removeSchemaByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete schema resource by id
     * @param {String} schemaId ID of schema to filter by
     * @param {module:api/SchemaApi~removeSchemaByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeSchemaById = function(schemaId, callback) {
      var postBody = null;

      // verify the required parameter 'schemaId' is set
      if (schemaId === undefined || schemaId === null) {
        throw new Error("Missing the required parameter 'schemaId' when calling removeSchemaById");
      }


      var pathParams = {
        'schemaId': schemaId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/schemas/{schemaId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveSchema operation.
     * @callback module:api/SchemaApi~saveSchemaCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new schema resource
     * @param {Object} data Provide your schema data information to save
     * @param {module:api/SchemaApi~saveSchemaCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveSchema = function(data, callback) {
      var postBody = data;

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveSchema");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/schemas', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateSchema operation.
     * @callback module:api/SchemaApi~updateSchemaCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update schema resource by id
     * @param {String} schemaId ID of schema to filter by
     * @param {Object} data Provide your schema data information to update
     * @param {module:api/SchemaApi~updateSchemaCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateSchema = function(schemaId, data, callback) {
      var postBody = data;

      // verify the required parameter 'schemaId' is set
      if (schemaId === undefined || schemaId === null) {
        throw new Error("Missing the required parameter 'schemaId' when calling updateSchema");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateSchema");
      }


      var pathParams = {
        'schemaId': schemaId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/schemas/{schemaId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
