/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.UdcTypeApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * UdcType service.
   * @module api/UdcTypeApi
   * @version 0.1.0
   */

  /**
   * Constructs a new UdcTypeApi. 
   * @alias module:api/UdcTypeApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllUdcTypes operation.
     * @callback module:api/UdcTypeApi~getAllUdcTypesCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all udc types resource without tenant
     * @param {String} sysCode Code of system to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter udc type by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/UdcTypeApi~getAllUdcTypesCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllUdcTypes = function(sysCode, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getAllUdcTypes");
      }


      var pathParams = {
        'sysCode': sysCode
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getAllUdcTypesTenant operation.
     * @callback module:api/UdcTypeApi~getAllUdcTypesTenantCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all udc types resource with tenant
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter udc type by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/UdcTypeApi~getAllUdcTypesTenantCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllUdcTypesTenant = function(tenantId, sysCode, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllUdcTypesTenant");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getAllUdcTypesTenant");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getUdcTypeById operation.
     * @callback module:api/UdcTypeApi~getUdcTypeByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a udc type without tenant resource by id
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {module:api/UdcTypeApi~getUdcTypeByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getUdcTypeById = function(sysCode, typeId, callback) {
      var postBody = null;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getUdcTypeById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling getUdcTypeById");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getUdcTypeTenantById operation.
     * @callback module:api/UdcTypeApi~getUdcTypeTenantByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a udc type with tenant resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {module:api/UdcTypeApi~getUdcTypeTenantByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getUdcTypeTenantById = function(tenantId, sysCode, typeId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getUdcTypeTenantById");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getUdcTypeTenantById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling getUdcTypeTenantById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeUdcTypeById operation.
     * @callback module:api/UdcTypeApi~removeUdcTypeByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete udc type resource without tenant by id
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {module:api/UdcTypeApi~removeUdcTypeByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeUdcTypeById = function(sysCode, typeId, callback) {
      var postBody = null;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling removeUdcTypeById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling removeUdcTypeById");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeUdcTypeTenantById operation.
     * @callback module:api/UdcTypeApi~removeUdcTypeTenantByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete udc type resource with tenant by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {module:api/UdcTypeApi~removeUdcTypeTenantByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeUdcTypeTenantById = function(tenantId, sysCode, typeId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeUdcTypeTenantById");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling removeUdcTypeTenantById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling removeUdcTypeTenantById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveUdcType operation.
     * @callback module:api/UdcTypeApi~saveUdcTypeCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new udc type resource without tenant
     * @param {String} sysCode Code of system to filter by
     * @param {Object} data Provide your udc type data information to save
     * @param {module:api/UdcTypeApi~saveUdcTypeCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveUdcType = function(sysCode, data, callback) {
      var postBody = data;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling saveUdcType");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveUdcType");
      }


      var pathParams = {
        'sysCode': sysCode
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveUdcTypeTenant operation.
     * @callback module:api/UdcTypeApi~saveUdcTypeTenantCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new udc type resource with tenant
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {Object} data Provide your udc type data information to save
     * @param {module:api/UdcTypeApi~saveUdcTypeTenantCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveUdcTypeTenant = function(tenantId, sysCode, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveUdcTypeTenant");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling saveUdcTypeTenant");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveUdcTypeTenant");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateUdcTenantType operation.
     * @callback module:api/UdcTypeApi~updateUdcTenantTypeCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update udc type resource with tenant by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {Object} data Provide your udc type data information to update
     * @param {module:api/UdcTypeApi~updateUdcTenantTypeCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateUdcTenantType = function(tenantId, sysCode, typeId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateUdcTenantType");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling updateUdcTenantType");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling updateUdcTenantType");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateUdcTenantType");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateUdcType operation.
     * @callback module:api/UdcTypeApi~updateUdcTypeCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update udc type resource with tenantout by id
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {Object} data Provide your udc type data information to update
     * @param {module:api/UdcTypeApi~updateUdcTypeCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateUdcType = function(sysCode, typeId, data, callback) {
      var postBody = data;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling updateUdcType");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling updateUdcType");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateUdcType");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
