/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.UdcValueApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * UdcValue service.
   * @module api/UdcValueApi
   * @version 0.1.0
   */

  /**
   * Constructs a new UdcValueApi. 
   * @alias module:api/UdcValueApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllUdcValues operation.
     * @callback module:api/UdcValueApi~getAllUdcValuesCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all udc values resource without tenant
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter udc value by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/UdcValueApi~getAllUdcValuesCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllUdcValues = function(sysCode, typeId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getAllUdcValues");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling getAllUdcValues");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}/values/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getAllUdcValuesTenant operation.
     * @callback module:api/UdcValueApi~getAllUdcValuesTenantCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all udc values resource with tenant
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter udc value by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/UdcValueApi~getAllUdcValuesTenantCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllUdcValuesTenant = function(tenantId, sysCode, typeId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllUdcValuesTenant");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getAllUdcValuesTenant");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling getAllUdcValuesTenant");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getUdcValueById operation.
     * @callback module:api/UdcValueApi~getUdcValueByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get udc value resource without tenant by id
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {String} valueId ID of udc value to filter by
     * @param {module:api/UdcValueApi~getUdcValueByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getUdcValueById = function(sysCode, typeId, valueId, callback) {
      var postBody = null;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getUdcValueById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling getUdcValueById");
      }

      // verify the required parameter 'valueId' is set
      if (valueId === undefined || valueId === null) {
        throw new Error("Missing the required parameter 'valueId' when calling getUdcValueById");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId,
        'valueId': valueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}/values/{valueId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getUdcValueTenantById operation.
     * @callback module:api/UdcValueApi~getUdcValueTenantByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get udc value resource with tenant by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {String} valueId ID of udc value to filter by
     * @param {module:api/UdcValueApi~getUdcValueTenantByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getUdcValueTenantById = function(tenantId, sysCode, typeId, valueId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getUdcValueTenantById");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling getUdcValueTenantById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling getUdcValueTenantById");
      }

      // verify the required parameter 'valueId' is set
      if (valueId === undefined || valueId === null) {
        throw new Error("Missing the required parameter 'valueId' when calling getUdcValueTenantById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId,
        'valueId': valueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/{valueId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeUdcValueById operation.
     * @callback module:api/UdcValueApi~removeUdcValueByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete udc value resource without tenant by id
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {String} valueId ID of udc value to filter by
     * @param {module:api/UdcValueApi~removeUdcValueByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeUdcValueById = function(sysCode, typeId, valueId, callback) {
      var postBody = null;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling removeUdcValueById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling removeUdcValueById");
      }

      // verify the required parameter 'valueId' is set
      if (valueId === undefined || valueId === null) {
        throw new Error("Missing the required parameter 'valueId' when calling removeUdcValueById");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId,
        'valueId': valueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}/values/{valueId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeUdcValueTenantById operation.
     * @callback module:api/UdcValueApi~removeUdcValueTenantByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete udc value resource with tenant by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {String} valueId ID of udc value to filter by
     * @param {module:api/UdcValueApi~removeUdcValueTenantByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeUdcValueTenantById = function(tenantId, sysCode, typeId, valueId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeUdcValueTenantById");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling removeUdcValueTenantById");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling removeUdcValueTenantById");
      }

      // verify the required parameter 'valueId' is set
      if (valueId === undefined || valueId === null) {
        throw new Error("Missing the required parameter 'valueId' when calling removeUdcValueTenantById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId,
        'valueId': valueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/{valueId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveUdcValue operation.
     * @callback module:api/UdcValueApi~saveUdcValueCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new udc value resource without tenant
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {Object} data Provide your udc value data information to save
     * @param {module:api/UdcValueApi~saveUdcValueCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveUdcValue = function(sysCode, typeId, data, callback) {
      var postBody = data;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling saveUdcValue");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling saveUdcValue");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveUdcValue");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}/values', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveUdcValueTenant operation.
     * @callback module:api/UdcValueApi~saveUdcValueTenantCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new udc value resource with tenant
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {Object} data Provide your udc value data information to save
     * @param {module:api/UdcValueApi~saveUdcValueTenantCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveUdcValueTenant = function(tenantId, sysCode, typeId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveUdcValueTenant");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling saveUdcValueTenant");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling saveUdcValueTenant");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveUdcValueTenant");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateUdcValue operation.
     * @callback module:api/UdcValueApi~updateUdcValueCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update udc value resource without tenant by id
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {String} valueId ID of udc value to filter by
     * @param {Object} data Provide your udc value data information to update
     * @param {module:api/UdcValueApi~updateUdcValueCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateUdcValue = function(sysCode, typeId, valueId, data, callback) {
      var postBody = data;

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling updateUdcValue");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling updateUdcValue");
      }

      // verify the required parameter 'valueId' is set
      if (valueId === undefined || valueId === null) {
        throw new Error("Missing the required parameter 'valueId' when calling updateUdcValue");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateUdcValue");
      }


      var pathParams = {
        'sysCode': sysCode,
        'typeId': typeId,
        'valueId': valueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/systems/{sysCode}/types/{typeId}/values/{valueId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateUdcValueTenant operation.
     * @callback module:api/UdcValueApi~updateUdcValueTenantCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update udc value resource with tenant by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} sysCode Code of system to filter by
     * @param {String} typeId ID of udc type to filter by
     * @param {String} valueId ID of udc value to filter by
     * @param {Object} data Provide your udc value data information to update
     * @param {module:api/UdcValueApi~updateUdcValueTenantCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateUdcValueTenant = function(tenantId, sysCode, typeId, valueId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateUdcValueTenant");
      }

      // verify the required parameter 'sysCode' is set
      if (sysCode === undefined || sysCode === null) {
        throw new Error("Missing the required parameter 'sysCode' when calling updateUdcValueTenant");
      }

      // verify the required parameter 'typeId' is set
      if (typeId === undefined || typeId === null) {
        throw new Error("Missing the required parameter 'typeId' when calling updateUdcValueTenant");
      }

      // verify the required parameter 'valueId' is set
      if (valueId === undefined || valueId === null) {
        throw new Error("Missing the required parameter 'valueId' when calling updateUdcValueTenant");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateUdcValueTenant");
      }


      var pathParams = {
        'tenantId': tenantId,
        'sysCode': sysCode,
        'typeId': typeId,
        'valueId': valueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/systems/{sysCode}/types/{typeId}/values/{valueId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
