/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.UserRoleApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * UserRole service.
   * @module api/UserRoleApi
   * @version 0.1.0
   */

  /**
   * Constructs a new UserRoleApi. 
   * @alias module:api/UserRoleApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllUserRoles operation.
     * @callback module:api/UserRoleApi~getAllUserRolesCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all user roles resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter user roles by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/UserRoleApi~getAllUserRolesCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllUserRoles = function(tenantId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllUserRoles");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/userroles/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getUserRoleById operation.
     * @callback module:api/UserRoleApi~getUserRoleByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a user role resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} userRole ID of user role to filter by
     * @param {module:api/UserRoleApi~getUserRoleByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getUserRoleById = function(tenantId, userRole, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getUserRoleById");
      }

      // verify the required parameter 'userRole' is set
      if (userRole === undefined || userRole === null) {
        throw new Error("Missing the required parameter 'userRole' when calling getUserRoleById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'userRole': userRole
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/userroles/{userRole}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeUserRoleById operation.
     * @callback module:api/UserRoleApi~removeUserRoleByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete user role resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} userRole ID of user role to filter by
     * @param {module:api/UserRoleApi~removeUserRoleByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeUserRoleById = function(tenantId, userRole, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeUserRoleById");
      }

      // verify the required parameter 'userRole' is set
      if (userRole === undefined || userRole === null) {
        throw new Error("Missing the required parameter 'userRole' when calling removeUserRoleById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'userRole': userRole
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/userroles/{userRole}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveUserRole operation.
     * @callback module:api/UserRoleApi~saveUserRoleCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new user role resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} data Provide your user role data information to save
     * @param {module:api/UserRoleApi~saveUserRoleCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveUserRole = function(tenantId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveUserRole");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveUserRole");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/userroles', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateUserRole operation.
     * @callback module:api/UserRoleApi~updateUserRoleCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update user role resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} userRole ID of user role to filter by
     * @param {Object} data Provide your user role data information to update
     * @param {module:api/UserRoleApi~updateUserRoleCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateUserRole = function(tenantId, userRole, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateUserRole");
      }

      // verify the required parameter 'userRole' is set
      if (userRole === undefined || userRole === null) {
        throw new Error("Missing the required parameter 'userRole' when calling updateUserRole");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateUserRole");
      }


      var pathParams = {
        'tenantId': tenantId,
        'userRole': userRole
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/userroles/{userRole}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
