/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.UserSecurityApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * UserSecurity service.
   * @module api/UserSecurityApi
   * @version 0.1.0
   */

  /**
   * Constructs a new UserSecurityApi. 
   * @alias module:api/UserSecurityApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllUserSecurities operation.
     * @callback module:api/UserSecurityApi~getAllUserSecuritiesCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all user securities resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter user security by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/UserSecurityApi~getAllUserSecuritiesCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllUserSecurities = function(tenantId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllUserSecurities");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/usersecurity/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getUserSecurityById operation.
     * @callback module:api/UserSecurityApi~getUserSecurityByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a user security resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} userSecurityId ID of user security to filter by
     * @param {module:api/UserSecurityApi~getUserSecurityByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getUserSecurityById = function(tenantId, userSecurityId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getUserSecurityById");
      }

      // verify the required parameter 'userSecurityId' is set
      if (userSecurityId === undefined || userSecurityId === null) {
        throw new Error("Missing the required parameter 'userSecurityId' when calling getUserSecurityById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'userSecurityId': userSecurityId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/usersecurity/{userSecurityId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeUserSecurityById operation.
     * @callback module:api/UserSecurityApi~removeUserSecurityByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete user security resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} userSecurityId ID of user security to filter by
     * @param {module:api/UserSecurityApi~removeUserSecurityByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeUserSecurityById = function(tenantId, userSecurityId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeUserSecurityById");
      }

      // verify the required parameter 'userSecurityId' is set
      if (userSecurityId === undefined || userSecurityId === null) {
        throw new Error("Missing the required parameter 'userSecurityId' when calling removeUserSecurityById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'userSecurityId': userSecurityId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/usersecurity/{userSecurityId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveUserSecurity operation.
     * @callback module:api/UserSecurityApi~saveUserSecurityCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new user security resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {Object} data Provide your user security data information to save
     * @param {module:api/UserSecurityApi~saveUserSecurityCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveUserSecurity = function(tenantId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveUserSecurity");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveUserSecurity");
      }


      var pathParams = {
        'tenantId': tenantId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/usersecurity', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateUserSecurity operation.
     * @callback module:api/UserSecurityApi~updateUserSecurityCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update user security resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} userSecurityId ID of user security to filter by
     * @param {Object} data Provide your user security data information to update
     * @param {module:api/UserSecurityApi~updateUserSecurityCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateUserSecurity = function(tenantId, userSecurityId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateUserSecurity");
      }

      // verify the required parameter 'userSecurityId' is set
      if (userSecurityId === undefined || userSecurityId === null) {
        throw new Error("Missing the required parameter 'userSecurityId' when calling updateUserSecurity");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateUserSecurity");
      }


      var pathParams = {
        'tenantId': tenantId,
        'userSecurityId': userSecurityId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/usersecurity/{userSecurityId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
