/*
 * workEvolve API
 * workEvolve Restful API generated by Swagger
 *
 * OpenAPI spec version: 0.1.0
 * Contact: development@workevolve.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.10
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.WorkEvolveApi) {
      root.WorkEvolveApi = {};
    }
    root.WorkEvolveApi.VersionApi = factory(root.WorkEvolveApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * Version service.
   * @module api/VersionApi
   * @version 0.1.0
   */

  /**
   * Constructs a new VersionApi. 
   * @alias module:api/VersionApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getAllVersions operation.
     * @callback module:api/VersionApi~getAllVersionsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all versions resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} proId ID of program to filter by
     * @param {Object} opts Optional parameters
     * @param {Object} opts.filter Filter versions by condition provided
     * @param {Number} opts.offset The number of items to skip before starting to collect the result set (default to 0)
     * @param {Number} opts.limit The number of items to return (default to 25)
     * @param {module:api/VersionApi~getAllVersionsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getAllVersions = function(tenantId, proId, opts, callback) {
      opts = opts || {};
      var postBody = opts['filter'];

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getAllVersions");
      }

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling getAllVersions");
      }


      var pathParams = {
        'tenantId': tenantId,
        'proId': proId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/programs/{proId}/versions/get', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getVersionById operation.
     * @callback module:api/VersionApi~getVersionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a version resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} proId ID of program to filter by
     * @param {String} versionId ID of version to filter by
     * @param {module:api/VersionApi~getVersionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.getVersionById = function(tenantId, proId, versionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling getVersionById");
      }

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling getVersionById");
      }

      // verify the required parameter 'versionId' is set
      if (versionId === undefined || versionId === null) {
        throw new Error("Missing the required parameter 'versionId' when calling getVersionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'proId': proId,
        'versionId': versionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/programs/{proId}/versions/{versionId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeVersionById operation.
     * @callback module:api/VersionApi~removeVersionByIdCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete version resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} proId ID of program to filter by
     * @param {String} versionId ID of version to filter by
     * @param {module:api/VersionApi~removeVersionByIdCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeVersionById = function(tenantId, proId, versionId, callback) {
      var postBody = null;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling removeVersionById");
      }

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling removeVersionById");
      }

      // verify the required parameter 'versionId' is set
      if (versionId === undefined || versionId === null) {
        throw new Error("Missing the required parameter 'versionId' when calling removeVersionById");
      }


      var pathParams = {
        'tenantId': tenantId,
        'proId': proId,
        'versionId': versionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/programs/{proId}/versions/{versionId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the saveVersion operation.
     * @callback module:api/VersionApi~saveVersionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Save a new version resource
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} proId ID of program to filter by
     * @param {Object} data Provide your version data information to save
     * @param {module:api/VersionApi~saveVersionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.saveVersion = function(tenantId, proId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling saveVersion");
      }

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling saveVersion");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling saveVersion");
      }


      var pathParams = {
        'tenantId': tenantId,
        'proId': proId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/programs/{proId}/versions', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateVersion operation.
     * @callback module:api/VersionApi~updateVersionCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update version resource by id
     * @param {String} tenantId ID of tenant to filter by
     * @param {String} proId ID of program to filter by
     * @param {String} versionId ID of version to filter by
     * @param {Object} data Provide your version data information to update
     * @param {module:api/VersionApi~updateVersionCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateVersion = function(tenantId, proId, versionId, data, callback) {
      var postBody = data;

      // verify the required parameter 'tenantId' is set
      if (tenantId === undefined || tenantId === null) {
        throw new Error("Missing the required parameter 'tenantId' when calling updateVersion");
      }

      // verify the required parameter 'proId' is set
      if (proId === undefined || proId === null) {
        throw new Error("Missing the required parameter 'proId' when calling updateVersion");
      }

      // verify the required parameter 'versionId' is set
      if (versionId === undefined || versionId === null) {
        throw new Error("Missing the required parameter 'versionId' when calling updateVersion");
      }

      // verify the required parameter 'data' is set
      if (data === undefined || data === null) {
        throw new Error("Missing the required parameter 'data' when calling updateVersion");
      }


      var pathParams = {
        'tenantId': tenantId,
        'proId': proId,
        'versionId': versionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['default'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tenants/{tenantId}/programs/{proId}/versions/{versionId}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
